dnl I'd like this to be edited in -*- Autoconf -*- mode...
dnl
AC_DEFUN([GST_HAVE_OPENGL], [

AC_ARG_WITH(opengl, 
	[  --with-opengl=path    set path to opengl 
  --without-opengl      don't try to detect opengl])

if test "$with_opengl" != no; then
  gst_cv_opengl_libs=""
  AC_CACHE_CHECK(for opengl, gst_cv_opengl, [
    gst_cv_opengl="no"
    test "$with_opengl" && test -d "$with_opengl" && \
      LDFLAGS="$LDFLAGS -L$with_opengl" \
      CPPFLAGS="$CPPFLAGS -I$with_opengl/../include"

    ac_save_LIBS="$LIBS"
	LIBS="$ac_save_LIBS -lglut -lGLU -lGL -lXext -lX11 -lm"

      cat > conftest.$ac_ext <<\EOF
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB);
  glutInitWindowSize (500, 500);
  glutInitWindowPosition (100, 100);
  glClearColor (0.0, 0.0, 0.0, 0.0);
  glShadeModel (GL_FLAT);
  exit(0);
}
EOF
      # Link the program.  If not cross-compiling, run it too,
      # to detect shared library dependancies.

      ok=yes
      (AC_TRY_EVAL(ac_link) && test -s conftest${ac_exeext})	         || ok=no
      test $cross_compiling = no && test $ok = yes && (./conftest; exit) || ok=no
      rm -rf conftest*

      if test $ok = yes; then
        gst_cv_opengl="yes"
        test "x$with_opengl" != x && test "$with_opengl" != yes \
	  && test -d "$with_opengl" \
	  && gst_cv_opengl_libs="-L$with_opengl -lglut -lGLU -lGL -lXext -lX11 -lm $lib"
        break
      fi
    LIBS="$ac_save_LIBS"
	LIBOPENGL=$gst_cv_opengl_libs
  ])

  if test "$gst_cv_opengl" != "no"; then
    LIBOPENGL="$gst_cv_opengl_libs"
    AC_SUBST(LIBOPENGL)
    AC_DEFINE(HAVE_OPENGL, 1,
          [Define if your system has the OPENGL library.])
  fi
fi

])dnl
