" ************* "
" Nurbs objects "
" ************* "

Object subclass: #Nurbs
	   instanceVariableNames: 'nurbPointer callbacks'
	   classVariableNames: ''
	   poolDictionaries: ''
	   category: 'OpenGL' !
OpenGL comment:
'My instances are Nurbs objects.'!

!Nurbs class methodsFor: 'initialize'!
newRenderer
	^ self new init !
!

!Nurbs methodsFor: 'initialize'!
init
	nurbPointer := self gluNewNurbsRender.
	^ self!
!
Nurbs methodsFor: 'working...'!
property: aProp value: avalue
	self gluNurbsProperty: nurbPointer property: aProp value: avalue!

addCallback: aCallback to: aReceiver selector: aSelector
	self gluNurbsCallback: nurbPointer event: aCallback to: aReceiver selector: aSelector!

surface: asKnotCount sKnots: asKnots tKnotCounts: atkKnotCount tKnots: atKnots 
	sStride: astride tStride: tstride 
	control: controlPoints 
	sOrder: aSOrder tOrder: aTOrder 
	type: aType
	self gluNurbsSuface: nurbPointer sKnotCounts: asKnotCount sKnots: asKnots tKnotCounts: atkKnotCount tKnots: atKnots 
	sStride: astride tStride: tstride 
	control: controlPoints 
	sOrder: aSOrder tOrder: aTOrder 
	type: aType!

gluBeginSurface
	self gluBeginSurface: nurbPointer!

gluEndSurface
	self gluEndSurface: nurbPointer!
!


!Nurbs methodsFor: 'private - C interface'!
gluNewNurbsRender
	<cCall: 'gluNewNurbsRenderer' returning: #cObject args: #()>!

gluNurbsProperty: nurbs property: aProp value: avalue
	<cCall: 'gluNurbsProperty' returning: #void args: #(#cObject #int #float)>!

gluNurbsCallback: nurbs event: anEvent to: aReceiver selector: aSelector
	<cCall: 'gluNurbsProperty' returning: #void args: #(#cObject #int #smalltalk #smalltalk)>!

gluNurbsSuface: nurbPointer sKnotCounts: asKnotsCount sKnots: asKnots tKnotCounts: atkKnotCount tKnots: atKnots 
	sStride: astride tStride: tstride 
	control: controlPoints 
	sOrder: aSOrder tOrder: aTOrder 
	type: aType
	<cCall: 'gluNurbsSurface' returning: #void args: #(#cObject #int #smalltalk #int #smalltalk #int #int #smalltalk  #int #int #int)>!

gluBeginSurface: nurbPointer
	<cCall: 'gluBeginSurface' returning: #void args: #(#cObject)>!

gluEndSurface: nurbPointer
	<cCall: 'gluEndSurface' returning: #void args: #(#cObject)>!
!





