" ********** "
" GLUT funcs "
" ********** "

!OpenGL methodsFor: 'GLUT'!

glutInit: aName
	init isNil ifTrue: [ 
		self cacheGlutInit: aName.
		init := true.
		] !

cacheGlutInit: aName
		<cCall: 'glutInit' returning: #void args: #( #string )>!

glutInitWindowPosition: aPoint
	self glutInitWindowPosition: aPoint x y: aPoint y !

glutInitWindowPosition: aX y: aY
	<cCall: 'glutInitWindowPosition' returning: #void args: #( #int #int )> !

	
glutInitWindowSize: aPoint
	self glutInitWindowSize: aPoint x height: aPoint y !
	
glutInitWindowSize: x height: y
	<cCall: 'glutInitWindowSize' returning: #void args: #( #int #int )> !

glutInitDisplayMode: mode
	<cCall: 'glutInitDisplayMode' returning: #void args: #( #int )> !

glutMainLoop
	<cCall: 'glutMainLoop' returning: #void args: #()> !

glutCreateWindow: aName
	<cCall: 'glutCreateWindow' returning: #int args: #( #string )> !

glutCreateSubWindow: aWindow from: startPoint to: size
	self glutCreateSubWindow: aWindow x: startPoint x y: startPoint y width: size x height: size y !

glutCreateSubWindow: aWindow x: startPointX y: startPointY width: sizeX height: sizeY 
	<cCall: 'glutCreateSubWindow' returning: #int args: #( #int #int #int #int #int )> !

glutDestroyWindow
	<cCall: 'glutDestroyWindow' returning: #void args: #( #int )> !

glutSetWindow: aWindow
	<cCall: 'glutSetWindow' returning: #void args: #( #int )> !

glutGetWindow
	<cCall: 'glutGetWindow' returning: #int args: #( #void )> !

glutSetWindowTitle: aTitle
	<cCall: 'glutSetWindowTitle' returning: #void args: #( #string )> !

glutSetIconTitle: aTitle
	<cCall: 'glutSetIconTitle' returning: #void args: #( #string )> !

glutReshapeWindow: aPoint
	self glutReshapeWindow: aPoint x height: aPoint y !

glutReshapeWindow: aWidth height: aHeight
	<cCall: 'glutReshapeWindow' returning: #void args: #( #int #int )> !

glutPositionWindow: aPoint
	self glutPositionWindow: aPoint x height: aPoint y !

glutPositionWindow: aX y: ay
	<cCall: 'glutPositionWindow' returning: #void args: #( #int #int )> !

glutShowWindow
	<cCall: 'glutShowWindow' returning: #void args: #( )> !

glutHideWindow
	<cCall: 'glutHideWindow' returning: #void args: #( )> !

glutIconifyWindow
	<cCall: 'glutIconifyWindow' returning: #void args: #( )> !

glutPushWindow
	<cCall: 'glutPushWindow' returning: #void args: #( )> !

glutPopWindow
	<cCall: 'glutPopWindow' returning: #void args: #( )> !

glutFullScreen
	<cCall: 'glutFullScreen' returning: #void args: #( )> !

glutPostWindowRedisplay: aWindow
	<cCall: 'glutPostWindowRedisplay' returning: #void args: #( #int )> !

glutPostRedisplay
	<cCall: 'glutPostRedisplay' returning: #void args: #()> !

glutSwapBuffers
	<cCall: 'glutSwapBuffers' returning: #void args: #( )> ! 

glutWarpPointers: aPoint
	self glutWarpPointers: aPoint x y: aPoint y!

glutWarpPointers: aX y: aY
	<cCall: 'glutPostRedisplay' returning: #void args: #( #int #int )> !
	
glutEstablishOverlay
	<cCall: 'glutEstablishOverlay' returning: #void args: #( )> ! 

glutRemoveOverlay
	<cCall: 'glutRemoveOverlay' returning: #void args: #( )> ! 

glutUseLayer: aLayer
	<cCall: 'glutUseLayer' returning: #void args: #( #int )> ! 

glutPostOverlayRedisplay
	<cCall: 'glutPostOverlayRedisplay' returning: #void args: #( )> !

glutPostWindowOverlayRedisplay: aWindow
	<cCall: 'glutPostWindowOverlayRedisplay' returning: #void args: #( #int )> ! 

glutShowOverlay
	<cCall: 'glutShowOverlay' returning: #void args: #( )> ! 

glutHideOverlay
	<cCall: 'glutHideOverlay' returning: #void args: #( )> ! 

glutCreateMenu: aSymbol
	"glutCreateMenu A creer... cependant il y a un callback !"
	<cCall: 'glutCreateMenu' returning: #int args: #( #smalltalk )>!

glutDestroyMenu: aMenu
	<cCall: 'glutDestroyMenu' returning: #void args: #( #int )>!

glutGetMenu
	<cCall: 'glutGetMenu' returning: #int args: #( )>!

glutSetMenu: aMenu
	<cCall: 'glutSetMenu' returning: #void args: #( #int )>!

glutAddMenuEntry: aLabel value: aValue
	<cCall: 'glutAddMenuEntry' returning: #void args: #( #string #int )>!

glutAddSubMenu: aLabel subMenu: aSubMenu
	<cCall: 'glutAddSubMenu' returning: #void args: #( #string #int )>!

glutChangeToMenuEntry: aItem label: aLabel value: aValue
	<cCall: 'glutChangeToMenuEntry' returning: #void args: #( #int #string #int )>!

glutChangeToSubMenu: aItem label: aLabel value: aValue
	<cCall: 'glutChangeToSubMenu' returning: #void args: #( #int #string #int )>!

glutRemoveMenuItem: item
	<cCall: 'glutRemoveMenuItem' returning: #void args: #( #int )>!

glutAttachMenu: button
	<cCall: 'glutAttachMenu' returning: #void args: #( #int )>!

glutDetachMenu: button
	<cCall: 'glutDetachMenu' returning: #void args: #( #int )>!

glutTimerFunc: time selector: aSelector value: aValue
	<cCall: 'glutTimerFunc' returning: #void args: #( #int #smalltalk #int)>!

glutIdleFunc: aSelector
	<cCall: 'glutIdleFunc' returning: #void args: #( #smalltalk )>!

glutGet: aQuery
	<cCall: 'glutGet' returning: #int args: #( #int )>!

glutDeviceGet: aQuery
	<cCall: 'glutDeviceGet' returning: #int args: #( #int )>!

glutGetModifiers
	<cCall: 'glutGetModifiers' returning: #int args: #( )>!

glutLayerGet: aQuery
	<cCall: 'glutLayerGet' returning: #int args: #( #int )>!

"glutBitmapCharacter( void* font, int character )"
"glutBitmapWidth( void* font, int character )"
"glutStrokeCharacter( void* font, int character )"
"glutStrokeWidth( void* font, int character )"
"glutBitmapLength( void* font, const unsigned char* string )"
"glutStrokeLength( void* font, const unsigned char* string )"

glutWireCube: aScale
	<cCall: 'glutWireCube' returning: #void args: #( #double )> ! 

glutSolidCube: aScale
	<cCall: 'glutSolidCube' returning: #void args: #( #double )> ! 

glutWireSphere: radius slices: slices stacks: stacks
	<cCall: 'glutWireSphere' returning: #void args: #( #double #int #int )> ! 

glutSolidSphere: radius slices: slices stacks: stacks
	<cCall: 'glutSolidSphere' returning: #void args: #( #double #int #int )> ! 

glutWireCone: base height: height slices: slices stacks: stacks
	<cCall: 'glutWireCone' returning: #void args: #( #double #double #int #int )> ! 

glutSolidCone: base height: height slices: slices stacks: stacks
	<cCall: 'glutSolidCone' returning: #void args: #( #double #double #int #int )> ! 

glutWireTorus: innerRadius outerRadius: outerRadius sides: sides stacks: stacks
	<cCall: 'glutWireCone' returning: #void args: #( #double #double #int #int )> ! 

glutSolidTorus: innerRadius outerRadius: outerRadius sides: sides stacks: stacks
	<cCall: 'glutSolidTorus' returning: #void args: #( #double #double #int #int )> ! 

glutWireDodecahedron
	<cCall: 'glutWireDodecahedron' returning: #void args: #( )> ! 

glutSolidDodecahedron
	<cCall: 'glutSolidDodecahedron' returning: #void args: #( )> ! 

glutWireOctahedron
	<cCall: 'glutWireOctahedron' returning: #void args: #( )> ! 

glutSolidOctahedron
	<cCall: 'glutSolidOctahedron' returning: #void args: #( )> ! 

glutWireTetrahedron
	<cCall: 'glutWireTetrahedron' returning: #void args: #( )> ! 

glutSolidTetrahedron
	<cCall: 'glutSolidTetrahedron' returning: #void args: #( )> ! 

glutWireIcosahedron
	<cCall: 'glutWireIcosahedron' returning: #void args: #( )> ! 

glutSolidIcosahedron
	<cCall: 'glutSolidIcosahedron' returning: #void args: #( )> ! 

glutWireTeapot: aScale
	<cCall: 'glutWireTeapot' returning: #void args: #( #double )> ! 

glutSolidTeapot: aScale
	<cCall: 'glutSolidTeapot' returning: #void args: #( #double )> ! 

glutGameModeString: aString
	<cCall: 'glutGameModeString' returning: #void args: #( #string )> ! 

glutEnterGameMode
	<cCall: 'glutEnterGameMode' returning: #void args: #( )> ! 
	
glutLeaveGameMode
	<cCall: 'glutLeaveGameMode' returning: #void args: #( )> ! 
	
glutGameModeGet: aQuery
	<cCall: 'glutGameModeGet' returning: #int args: #( #int )> ! 
	
glutVideoResizeGet: aQuery
	<cCall: 'glutVideoResizeGet' returning: #int args: #( #int )> ! 
	
glutSetupVideoResizing
	<cCall: 'glutSetupVideoResizing' returning: #void args: #( )> ! 
	
glutStopVideoResizing
	<cCall: 'glutStopVideoResizing' returning: #void args: #( )> ! 
	
glutVideoResize: startPoint to: aSize
	self glutVideoResize: startPoint x y: startPoint y width: aSize x height: aSize y!

glutVideoResize: x y: y width: width height: height
	<cCall: 'glutVideoResize' returning: #void args: #( #int #int #int #int )> ! 

glutVideoPan: startPoint to: aSize
	self glutVideoPan: startPoint x y: startPoint y width: aSize x height: aSize y!

glutVideoPan: x y: y width: width height: height
	<cCall: 'glutVideoPan' returning: #void args: #( #int #int #int #int )> ! 

glutSetColor: colorNumber color: aColor
	self glutSetColor: colorNumber red: aColor red green: aColor green blue: aColor blue!

glutSetColor: colorNumber red: red green: green blue: blue
	<cCall: 'glutSetColor' returning: #void args: #( #int #float #float #float )> ! 
	
glutGetColor: colorNumber
	^ Color 
		red: (self glutGetColor: colorNumber component: OpenGL GlutRed)
		green: (self glutGetColor: colorNumber component: OpenGL GlutGreen)
		blue: (self glutGetColor: colorNumber component: OpenGL GlutBlue)!

glutGetColor: colorNumber component: aComponent
	<cCall: 'glutGetColor' returning: #void args: #( #int #int )> ! 

glutCopyColormap: window
	<cCall: 'glutCopyColormap' returning: #void args: #( #int )> ! 

glutIgnoreKeyRepeat: ingnore
	<cCall: 'glutIgnoreKeyRepeat' returning: #void args: #( #int )> ! 

glutSetKeyRepeat: repeatMode
	<cCall: 'glutSetKeyRepeat' returning: #void args: #( #int )> ! 

glutForceJoystickFunc
	<cCall: 'glutForceJoystickFunc' returning: #void args: #( #int )> ! 

glutForceJoystickFunc
	<cCall: 'glutForceJoystickFunc' returning: #void args: #( )> !

glutExtensionSupported: extension
	<cCall: 'glutExtensionSupported' returning: #int args: #( #string )> !

glutReportErrors
	<cCall: 'glutReportErrors' returning: #void args: #( )> !

!

