#include "config.h"
#include "gstpub.h"
#include "gst.h"

#include <stdio.h>
#include <GL/gl.h>

static VMProxy* _opengl_vm_proxy = NULL ;
#define nil  _opengl_vm_proxy->nilOOP

#define DEBUG 1

#ifdef DEBUG
static FILE* fp = NULL ;
#endif


void gst_opengl_glPolygonStipple ( const GLubyte *mask )
{
  glPolygonStipple (mask) ;
}
void gst_opengl_glGetPolygonStipple ( GLubyte *mask )
{
  glGetPolygonStipple (mask) ;
}
void gst_opengl_glEdgeFlagv ( const GLboolean *flag )
{
  glEdgeFlagv (flag) ;
}
void gst_opengl_glClipPlane ( GLenum plane, const GLdouble *equation )
{
  glClipPlane (plane, equation) ;
}
void gst_opengl_glGetClipPlane ( GLenum plane, GLdouble *equation )
{
  glGetClipPlane (plane, equation) ;
}
void gst_opengl_glGetBooleanv ( GLenum pname, GLboolean *params )
{
  glGetBooleanv (pname, params) ;
}
void gst_opengl_glGetDoublev ( GLenum pname, GLdouble *params )
{
  glGetDoublev (pname, params) ;
}
void gst_opengl_glGetFloatv ( GLenum pname, GLfloat *params )
{
  glGetFloatv (pname, params) ;
}
void gst_opengl_glGetIntegerv ( GLenum pname, GLint *params )
{
  glGetIntegerv (pname, params) ;
}
void gst_opengl_glLoadMatrixd ( const GLdouble *m )
{
  glLoadMatrixd (m) ;
}
void gst_opengl_glLoadMatrixf ( const GLfloat *m )
{
  glLoadMatrixf (m) ;
}
void gst_opengl_glMultMatrixd ( const GLdouble *m )
{
  glMultMatrixd (m) ;
}
void gst_opengl_glMultMatrixf ( const GLfloat *m )
{
  glMultMatrixf (m) ;
}

void gst_opengl_glCallLists( GLsizei n, GLenum type, OOP anArray)
{
  size_t size = _opengl_vm_proxy->OOPSize(anArray) ;
  if(size > 0) {
	GLint* params = alloca(sizeof(GLint) * size) ;
	int i ;
	for(i = 0 ; i < size ; ++i) 
	  params[i] =
		_opengl_vm_proxy->OOPToInt(_opengl_vm_proxy->OOPAt(anArray, i)) ;
	
	glCallLists( n, type, params );
  }
}

void gst_opengl_glVertex2dv ( const GLdouble *v )
{
  glVertex2dv (v) ;
}
void gst_opengl_glVertex2fv ( const GLfloat *v )
{
  glVertex2fv (v) ;
}
void gst_opengl_glVertex2iv ( const GLint *v )
{
  glVertex2iv (v) ;
}
void gst_opengl_glVertex2sv ( const GLshort *v )
{
  glVertex2sv (v) ;
}
void gst_opengl_glVertex3dv ( const GLdouble *v )
{
  glVertex3dv (v) ;
}
void gst_opengl_glVertex3fv ( const GLfloat *v )
{
  glVertex3fv (v) ;
}
void gst_opengl_glVertex3iv ( const GLint *v )
{
  glVertex3iv (v) ;
}
void gst_opengl_glVertex3sv ( const GLshort *v )
{
  glVertex3sv (v) ;
}
void gst_opengl_glVertex4dv ( const GLdouble *v )
{
  glVertex4dv (v) ;
}
void gst_opengl_glVertex4fv ( const GLfloat *v )
{
  glVertex4fv (v) ;
}
void gst_opengl_glVertex4iv ( const GLint *v )
{
  glVertex4iv (v) ;
}
void gst_opengl_glVertex4sv ( const GLshort *v )
{
  glVertex4sv (v) ;
}
void gst_opengl_glNormal3bv ( const GLbyte *v )
{
  glNormal3bv (v) ;
}
void gst_opengl_glNormal3dv ( const GLdouble *v )
{
  glNormal3dv (v) ;
}
void gst_opengl_glNormal3fv ( const GLfloat *v )
{
  glNormal3fv (v) ;
}
void gst_opengl_glNormal3iv ( const GLint *v )
{
  glNormal3iv (v) ;
}
void gst_opengl_glNormal3sv ( const GLshort *v )
{
  glNormal3sv (v) ;
}
void gst_opengl_glIndexdv ( const GLdouble *c )
{
  glIndexdv (c) ;
}
void gst_opengl_glIndexfv ( const GLfloat *c )
{
  glIndexfv (c) ;
}
void gst_opengl_glIndexiv ( const GLint *c )
{
  glIndexiv (c) ;
}
void gst_opengl_glIndexsv ( const GLshort *c )
{
  glIndexsv (c) ;
}
void gst_opengl_glIndexubv ( const GLubyte *c )
{
  glIndexubv (c) ;
}
void gst_opengl_glColor3bv ( const GLbyte *v )
{
  glColor3bv (v) ;
}
void gst_opengl_glColor3dv ( const GLdouble *v )
{
  glColor3dv (v) ;
}
void gst_opengl_glColor3fv ( const GLfloat *v )
{
  glColor3fv (v) ;
}
void gst_opengl_glColor3iv ( const GLint *v )
{
  glColor3iv (v) ;
}
void gst_opengl_glColor3sv ( const GLshort *v )
{
  glColor3sv (v) ;
}
void gst_opengl_glColor3ubv ( const GLubyte *v )
{
  glColor3ubv (v) ;
}
void gst_opengl_glColor3uiv ( const GLuint *v )
{
  glColor3uiv (v) ;
}
void gst_opengl_glColor3usv ( const GLushort *v )
{
  glColor3usv (v) ;
}
void gst_opengl_glColor4bv ( const GLbyte *v )
{
  glColor4bv (v) ;
}
void gst_opengl_glColor4dv ( const GLdouble *v )
{
  glColor4dv (v) ;
}
void gst_opengl_glColor4fv ( const GLfloat *v )
{
  glColor4fv (v) ;
}
void gst_opengl_glColor4iv ( const GLint *v )
{
  glColor4iv (v) ;
}
void gst_opengl_glColor4sv ( const GLshort *v )
{
  glColor4sv (v) ;
}
void gst_opengl_glColor4ubv ( const GLubyte *v )
{
  glColor4ubv (v) ;
}
void gst_opengl_glColor4uiv ( const GLuint *v )
{
  glColor4uiv (v) ;
}
void gst_opengl_glColor4usv ( const GLushort *v )
{
  glColor4usv (v) ;
}
void gst_opengl_glTexCoord1dv ( const GLdouble *v )
{
  glTexCoord1dv (v) ;
}
void gst_opengl_glTexCoord1fv ( const GLfloat *v )
{
  glTexCoord1fv (v) ;
}
void gst_opengl_glTexCoord1iv ( const GLint *v )
{
  glTexCoord1iv (v) ;
}
void gst_opengl_glTexCoord1sv ( const GLshort *v )
{
  glTexCoord1sv (v) ;
}
void gst_opengl_glTexCoord2dv ( const GLdouble *v )
{
  glTexCoord2dv (v) ;
}
void gst_opengl_glTexCoord2fv ( const GLfloat *v )
{
  glTexCoord2fv (v) ;
}
void gst_opengl_glTexCoord2iv ( const GLint *v )
{
  glTexCoord2iv (v) ;
}
void gst_opengl_glTexCoord2sv ( const GLshort *v )
{
  glTexCoord2sv (v) ;
}
void gst_opengl_glTexCoord3dv ( const GLdouble *v )
{
  glTexCoord3dv (v) ;
}
void gst_opengl_glTexCoord3fv ( const GLfloat *v )
{
  glTexCoord3fv (v) ;
}
void gst_opengl_glTexCoord3iv ( const GLint *v )
{
  glTexCoord3iv (v) ;
}
void gst_opengl_glTexCoord3sv ( const GLshort *v )
{
  glTexCoord3sv (v) ;
}
void gst_opengl_glTexCoord4dv ( const GLdouble *v )
{
  glTexCoord4dv (v) ;
}
void gst_opengl_glTexCoord4fv ( const GLfloat *v )
{
  glTexCoord4fv (v) ;
}
void gst_opengl_glTexCoord4iv ( const GLint *v )
{
  glTexCoord4iv (v) ;
}
void gst_opengl_glTexCoord4sv ( const GLshort *v )
{
  glTexCoord4sv (v) ;
}
void gst_opengl_glRasterPos2dv ( OOP anArray )
{
  size_t size = _opengl_vm_proxy->OOPSize(anArray) ;
  if(size > 0) {
	GLdouble* params = alloca(sizeof(GLdouble) * size) ;
	int i ;
	for(i = 0 ; i < size ; ++i) 
	  params[i] = (double)
		_opengl_vm_proxy->OOPToLongDouble(_opengl_vm_proxy->OOPAt(anArray, i)) ;
	glRasterPos2dv (params) ;
  }
}
void gst_opengl_glRasterPos2fv ( OOP anArray )
{
  size_t size = _opengl_vm_proxy->OOPSize(anArray) ;
  if(size > 0) {
	GLfloat* params = alloca(sizeof(GLfloat) * size) ;
	int i ;
	for(i = 0 ; i < size ; ++i) 
	  params[i] = 
		_opengl_vm_proxy->OOPToFloat(_opengl_vm_proxy->OOPAt(anArray, i)) ;
	glRasterPos2fv (params) ;
  }
}
void gst_opengl_glRasterPos2iv ( OOP anArray )
{
  size_t size = _opengl_vm_proxy->OOPSize(anArray) ;
  if(size > 0) {
	GLint* params = alloca(sizeof(GLint) * size) ;
	int i ;
	for(i = 0 ; i < size ; ++i) 
	  params[i] = 
		_opengl_vm_proxy->OOPToInt(_opengl_vm_proxy->OOPAt(anArray, i)) ;
	glRasterPos2iv (params) ;
  }
}
void gst_opengl_glRasterPos2sv ( OOP anArray )
{
  size_t size = _opengl_vm_proxy->OOPSize(anArray) ;
  if(size > 0) {
	GLshort* params = alloca(sizeof(GLshort) * size) ;
	int i ;
	for(i = 0 ; i < size ; ++i) 
	  params[i] = (short)
		_opengl_vm_proxy->OOPToInt(_opengl_vm_proxy->OOPAt(anArray, i)) ;
	glRasterPos2sv (params) ;
  }
}
void gst_opengl_glRasterPos3dv ( OOP anArray )
{
  size_t size = _opengl_vm_proxy->OOPSize(anArray) ;
  if(size > 0) {
	GLdouble* params = alloca(sizeof(GLdouble) * size) ;
	int i ;
	for(i = 0 ; i < size ; ++i) 
	  params[i] = (double)
		_opengl_vm_proxy->OOPToLongDouble(_opengl_vm_proxy->OOPAt(anArray, i)) ;
	glRasterPos3dv (params) ;
  }
}
void gst_opengl_glRasterPos3fv ( OOP anArray )
{
  size_t size = _opengl_vm_proxy->OOPSize(anArray) ;
  if(size > 0) {
	GLfloat* params = alloca(sizeof(GLfloat) * size) ;
	int i ;
	for(i = 0 ; i < size ; ++i) 
	  params[i] = 
		_opengl_vm_proxy->OOPToFloat(_opengl_vm_proxy->OOPAt(anArray, i)) ;
	glRasterPos3fv (params) ;
  }
}
void gst_opengl_glRasterPos3iv ( OOP anArray )
{
  size_t size = _opengl_vm_proxy->OOPSize(anArray) ;
  if(size > 0) {
	GLint* params = alloca(sizeof(GLint) * size) ;
	int i ;
	for(i = 0 ; i < size ; ++i) 
	  params[i] = 
		_opengl_vm_proxy->OOPToInt(_opengl_vm_proxy->OOPAt(anArray, i)) ;
	glRasterPos3iv (params) ;
  }
}
void gst_opengl_glRasterPos3sv ( OOP anArray )
{
  size_t size = _opengl_vm_proxy->OOPSize(anArray) ;
  if(size > 0) {
	GLshort* params = alloca(sizeof(GLshort) * size) ;
	int i ;
	for(i = 0 ; i < size ; ++i) 
	  params[i] = (short)
		_opengl_vm_proxy->OOPToInt(_opengl_vm_proxy->OOPAt(anArray, i)) ;
	glRasterPos3sv (params) ;
  }
}
void gst_opengl_glRasterPos4dv ( OOP anArray )
{
  size_t size = _opengl_vm_proxy->OOPSize(anArray) ;
  if(size > 0) {
	GLdouble* params = alloca(sizeof(GLdouble) * size) ;
	int i ;
	for(i = 0 ; i < size ; ++i) 
	  params[i] = (double)
		_opengl_vm_proxy->OOPToLongDouble(_opengl_vm_proxy->OOPAt(anArray, i)) ;
	glRasterPos4dv (params) ;
  }
}
void gst_opengl_glRasterPos4fv ( OOP anArray )
{
  size_t size = _opengl_vm_proxy->OOPSize(anArray) ;
  if(size > 0) {
	GLfloat* params = alloca(sizeof(GLfloat) * size) ;
	int i ;
	for(i = 0 ; i < size ; ++i) 
	  params[i] = 
		_opengl_vm_proxy->OOPToFloat(_opengl_vm_proxy->OOPAt(anArray, i)) ;
	glRasterPos4fv (params) ;
  }
}
void gst_opengl_glRasterPos4iv ( OOP anArray )
{
  size_t size = _opengl_vm_proxy->OOPSize(anArray) ;
  if(size > 0) {
	GLint* params = alloca(sizeof(GLint) * size) ;
	int i ;
	for(i = 0 ; i < size ; ++i) 
	  params[i] = 
		_opengl_vm_proxy->OOPToInt(_opengl_vm_proxy->OOPAt(anArray, i)) ;
	glRasterPos4iv (params) ;
  }
}
void gst_opengl_glRasterPos4sv ( OOP anArray )
{
  size_t size = _opengl_vm_proxy->OOPSize(anArray) ;
  if(size > 0) {
	GLshort* params = alloca(sizeof(GLshort) * size) ;
	int i ;
	for(i = 0 ; i < size ; ++i) 
	  params[i] = (short)
		_opengl_vm_proxy->OOPToInt(_opengl_vm_proxy->OOPAt(anArray, i)) ;
	glRasterPos4sv (params) ;
  }
}
void gst_opengl_glRectdv ( const GLdouble *v1, const GLdouble *v2 )
{
  glRectdv (v1, v2) ;
}
void gst_opengl_glRectfv ( const GLfloat *v1, const GLfloat *v2 )
{
  glRectfv (v1, v2) ;
}
void gst_opengl_glRectiv ( const GLint *v1, const GLint *v2 )
{
  glRectiv (v1, v2) ;
}
void gst_opengl_glRectsv ( const GLshort *v1, const GLshort *v2 )
{
  glRectsv (v1, v2) ;
}
void gst_opengl_glEdgeFlagPointer ( GLsizei stride, const GLvoid *ptr )
{
  glEdgeFlagPointer (stride, ptr) ;
}
void gst_opengl_glGetPointerv ( GLenum pname, GLvoid **params )
{
  glGetPointerv (pname, params) ;
}
void gst_opengl_glLightfv( GLenum light, GLenum pname, OOP anArray )
{
  size_t size = _opengl_vm_proxy->OOPSize(anArray) ;
  if(size > 0) {
	GLfloat* params = alloca(sizeof(GLfloat) * size) ;
	int i ;
	for(i = 0 ; i < size ; ++i) 
	  params[i] = 
		_opengl_vm_proxy->OOPToFloat(_opengl_vm_proxy->OOPAt(anArray, i)) ;
	glLightfv( light, pname, params );
  }
}
void gst_opengl_glLightiv( GLenum light, GLenum pname, OOP anArray )
{
  size_t size = _opengl_vm_proxy->OOPSize(anArray) ;
  if(size > 0) {
	GLint* params = alloca(sizeof(GLint) * size) ;
	int i ;
	for(i = 0 ; i < size ; ++i) 
	  params[i] = 
		_opengl_vm_proxy->OOPToInt(_opengl_vm_proxy->OOPAt(anArray, i)) ;
	glLightiv( light, pname, params ) ;
  }
}
void gst_opengl_glGetLightfv( GLenum light, GLenum pname, GLfloat *params )
{
  glGetLightfv( light, pname, params ) ;
}
void gst_opengl_glGetLightiv( GLenum light, GLenum pname, GLint *params )
{
  glGetLightiv( light, pname, params ) ;
}
void gst_opengl_glLightModelfv ( GLenum pname, const GLfloat *params )
{
  glLightModelfv (pname, params) ;
}
void gst_opengl_glLightModeliv ( GLenum pname, const GLint *params )
{
  glLightModeliv (pname, params) ;
}
void gst_opengl_glMaterialfv ( GLenum face, GLenum pname, OOP anArray)
{
  size_t size = _opengl_vm_proxy->OOPSize(anArray) ;
  if(size > 0) {
	GLfloat* params = alloca(sizeof(GLfloat) * size) ;
	int i ;
	for(i = 0 ; i < size ; ++i) 
	  {
		params[i] = 
		  _opengl_vm_proxy->OOPToFloat(_opengl_vm_proxy->OOPAt(anArray, i)) ;
	  }
	glMaterialfv (face, pname, params) ;
  }
}
void gst_opengl_glMaterialiv ( GLenum face, GLenum pname, OOP anArray )
{
  int size = _opengl_vm_proxy->OOPSize(anArray) ;
  if(size > 0) {
	GLint* params = alloca(sizeof(GLint) * size) ;
	int i ;
	for(i = 0 ; i < size ; ++i) 
	  params[i] = 
		_opengl_vm_proxy->OOPToInt(ARRAY_OOP_AT(anArray, i)) ;
	glMaterialiv (face, pname, params) ;
  }
}
void gst_opengl_glGetMaterialfv ( GLenum face, GLenum pname, GLfloat *params )
{
  glGetMaterialfv (face, pname, params) ;
}
void gst_opengl_glGetMaterialiv ( GLenum face, GLenum pname, GLint *params )
{
  glGetMaterialiv (face, pname, params) ;
}
void gst_opengl_glGetPixelMapfv ( GLenum map, GLfloat *values )
{
  glGetPixelMapfv (map, values) ;
}
void gst_opengl_glGetPixelMapuiv ( GLenum map, GLuint *values )
{
  glGetPixelMapuiv (map, values) ;
}
void gst_opengl_glGetPixelMapusv ( GLenum map, GLushort *values )
{
  glGetPixelMapusv (map, values) ;
}
void gst_opengl_glTexGendv ( GLenum coord, GLenum pname, const GLdouble *params )
{
  glTexGendv (coord, pname, params) ;
}
void gst_opengl_glTexGenfv ( GLenum coord, GLenum pname, const GLfloat *params )
{
  glTexGenfv (coord, pname, params) ;
}
void gst_opengl_glTexGeniv ( GLenum coord, GLenum pname, const GLint *params )
{
  glTexGeniv (coord, pname, params) ;
}
void gst_opengl_glGetTexGendv ( GLenum coord, GLenum pname, GLdouble *params )
{
  glGetTexGendv (coord, pname, params) ;
}
void gst_opengl_glGetTexGenfv ( GLenum coord, GLenum pname, GLfloat *params )
{
  glGetTexGenfv (coord, pname, params) ;
}
void gst_opengl_glGetTexGeniv ( GLenum coord, GLenum pname, GLint *params )
{
  glGetTexGeniv (coord, pname, params) ;
}
void gst_opengl_glTexEnvfv ( GLenum target, GLenum pname, const GLfloat *params )
{
  glTexEnvfv (target, pname, params) ;
}
void gst_opengl_glTexEnviv ( GLenum target, GLenum pname, const GLint *params )
{
  glTexEnviv (target, pname, params) ;
}
void gst_opengl_glGetTexEnvfv ( GLenum target, GLenum pname, GLfloat *params )
{
  glGetTexEnvfv (target, pname, params) ;
}
void gst_opengl_glGetTexEnviv ( GLenum target, GLenum pname, GLint *params )
{
  glGetTexEnviv (target, pname, params) ;
}
void gst_opengl_glTexParameterf ( GLenum target, GLenum pname, GLfloat param )
{
  glTexParameterf (target, pname, param) ;
}
void gst_opengl_glGenTextures ( GLsizei n, GLuint *textures )
{
  glGenTextures (n, textures) ;
}
void gst_opengl_glTexSubImage1D( GLenum target, GLint level,
								 GLint xoffset,
								 GLsizei width, GLenum format,
								 GLenum type, const GLvoid *pixels )
{
  glTexSubImage1D( target, level, xoffset, width, format, type, pixels ) ;
}

void gst_opengl_glTexSubImage2D( GLenum target, GLint level,
								 GLint xoffset, GLint yoffset,
								 GLsizei width, GLsizei height,
								 GLenum format, GLenum type,
								 const GLvoid *pixels )
{
  glTexSubImage2D( target, level, xoffset, yoffset, width, height, format, type, pixels ) ;
}

void gst_opengl_glMap1d( GLenum target, GLdouble u1, GLdouble u2,
						 GLint stride,
						 GLint order, 
						 OOP arrayOfPoints )
{
  GLdouble *points ;
  size_t i ;
  size_t size = _opengl_vm_proxy->OOPSize(arrayOfPoints) ;

  if(size <= 0) return ;		/* Should fire an exception */
  points = alloca(sizeof(GLdouble)*size) ;
  for(i = 0 ; i < size ; ++i)
	points[i] = _opengl_vm_proxy->OOPToLongDouble(_opengl_vm_proxy->OOPAt(arrayOfPoints, i)) ;
  glMap1d( target, u1, u2, stride, order, points ) ;
}
void gst_opengl_glMap1f( GLenum target, GLfloat u1, GLfloat u2,
                               GLint stride,
                               GLint order, OOP arrayOfPoints )
{
  GLfloat *points ;
  size_t i ;
  size_t size = _opengl_vm_proxy->OOPSize(arrayOfPoints) ;

  if(size <= 0) return ;		/* Should fire an exception */
  points = alloca(sizeof(GLfloat)*size) ;
  for(i = 0 ; i < size ; ++i)
	points[i] = _opengl_vm_proxy->OOPToLongDouble(_opengl_vm_proxy->OOPAt(arrayOfPoints, i)) ;
  glMap1f( target, u1, u2, stride, order, points ) ;
}

void gst_opengl_glMap2d( GLenum target,
		     GLdouble u1, GLdouble u2, GLint ustride, GLint uorder,
		     GLdouble v1, GLdouble v2, GLint vstride, GLint vorder,
		     OOP arrayOfPoints )
{
  GLdouble *points ;
  size_t i ;
  size_t size = _opengl_vm_proxy->OOPSize(arrayOfPoints) ;

  if(size <= 0) return ;		/* Should fire an exception */
  points = alloca(sizeof(GLdouble)*size) ;
  for(i = 0 ; i < size ; ++i)
	points[i] = _opengl_vm_proxy->OOPToLongDouble(_opengl_vm_proxy->OOPAt(arrayOfPoints, i)) ;
  glMap2d( target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points ) ;
}
void gst_opengl_glMap2f( GLenum target,
		     GLfloat u1, GLfloat u2, GLint ustride, GLint uorder,
		     GLfloat v1, GLfloat v2, GLint vstride, GLint vorder,
		     OOP arrayOfPoints )
{
  GLfloat *points ;
  size_t i ;
  size_t size = _opengl_vm_proxy->OOPSize(arrayOfPoints) ;

#ifdef DEBUG
  if( (fp = fopen("/home/olivier/gst.dbg", "a+")) != NULL) {
	fprintf(fp, "glMap2f (%d) (%d %f %f %d %d %f %f %d %d) \n", size, target, u1, u2, ustride, uorder, v1, v2, vstride, vorder ) ;
	fflush(fp) ;
  }
#endif  
  if(size <= 0) return ;		/* Should fire an exception */
  points = alloca(sizeof(GLfloat)*size) ;
  for(i = 0 ; i < size ; ++i) {
	points[i] = _opengl_vm_proxy->OOPToFloat(_opengl_vm_proxy->OOPAt(arrayOfPoints, i)) ;
#ifdef DEBUG
  if( fp != NULL) {
	fprintf(fp, "%f ", points[i]) ;
	fflush(fp) ;
  }
#endif
  }
  glMap2f( target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points ) ;
#ifdef DEBUG
  if( fp != NULL) {
	fprintf(fp, "\n ") ;
	fclose(fp) ;
	fp = NULL ;
  }
#endif
}

void gst_opengl_glDeleteTextures ( GLsizei n, const GLuint *textures)
{
  glDeleteTextures (n, textures) ;
}
void gst_opengl_glGetMapdv ( GLenum target, GLenum query, GLdouble *v )
{
  glGetMapdv (target, query, v) ;
}
void gst_opengl_glGetMapfv ( GLenum target, GLenum query, GLfloat *v )
{
  glGetMapfv (target, query, v) ;
}
void gst_opengl_glGetMapiv ( GLenum target, GLenum query, GLint *v )
{
  glGetMapiv (target, query, v) ;
}
void gst_opengl_glEvalCoord1dv ( const GLdouble *u )
{
  glEvalCoord1dv (u) ;
}
void gst_opengl_glEvalCoord1fv ( const GLfloat *u )
{
  glEvalCoord1fv (u) ;
}
void gst_opengl_glEvalCoord2dv ( const GLdouble *u )
{
  glEvalCoord2dv (u) ;
}
void gst_opengl_glEvalCoord2fv ( const GLfloat *u )
{
  glEvalCoord2fv (u) ;
}
void gst_opengl_glFogfv ( GLenum pname, const GLfloat *params )
{
  glFogfv (pname, params) ;
}
void gst_opengl_glFogiv ( GLenum pname, const GLint *params )
{
  glFogiv (pname, params) ;
}
void gst_opengl_glFeedbackBuffer ( GLsizei size, GLenum type, GLfloat *buffer )
{
  glFeedbackBuffer (size, type, buffer) ;
}
void gst_opengl_glSelectBuffer ( GLsizei size, GLuint *buffer )
{
  glSelectBuffer (size, buffer) ;
}
void gst_opengl_glCompressedTexImage1D ( GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize, const GLvoid *data )
{
  glCompressedTexImage1D (target, level, internalformat, width, border, imageSize, data) ;
}
void gst_opengl_glCompressedTexImage2D ( GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const GLvoid *data )
{
  glCompressedTexImage2D (target, level, internalformat, width, height, border, imageSize, data) ;
}
void gst_opengl_glCompressedTexImage3D ( GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const GLvoid *data )
{
  glCompressedTexImage3D (target, level, internalformat, width, height, depth, border, imageSize, data) ;
}
void gst_opengl_glCompressedTexSubImage1D ( GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize, const GLvoid *data )
{
  glCompressedTexSubImage1D (target, level, xoffset, width, format, imageSize, data) ;
}
void gst_opengl_glCompressedTexSubImage2D ( GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const GLvoid *data )
{
  glCompressedTexSubImage2D (target, level, xoffset, yoffset, width, height, format, imageSize, data) ;
}
void gst_opengl_glCompressedTexSubImage3D ( GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const GLvoid *data )
{
  glCompressedTexSubImage3D (target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, data) ;
}
void gst_opengl_glGetCompressedTexImage ( GLenum target, GLint lod, GLvoid *img )
{
  glGetCompressedTexImage (target, lod, img) ;
}
void gst_opengl_glMultiTexCoord1dv ( GLenum target, const GLdouble *v )
{
  glMultiTexCoord1dv (target, v) ;
}
void gst_opengl_glMultiTexCoord1fv ( GLenum target, const GLfloat *v )
{
  glMultiTexCoord1fv (target, v) ;
}
void gst_opengl_glMultiTexCoord1iv ( GLenum target, const GLint *v )
{
  glMultiTexCoord1iv (target, v) ;
}
void gst_opengl_glMultiTexCoord1sv ( GLenum target, const GLshort *v )
{
  glMultiTexCoord1sv (target, v) ;
}
void gst_opengl_glMultiTexCoord2dv ( GLenum target, const GLdouble *v )
{
  glMultiTexCoord2dv (target, v) ;
}
void gst_opengl_glMultiTexCoord2fv ( GLenum target, const GLfloat *v )
{
  glMultiTexCoord2fv (target, v) ;
}
void gst_opengl_glMultiTexCoord2iv ( GLenum target, const GLint *v )
{
  glMultiTexCoord2iv (target, v) ;
}
void gst_opengl_glMultiTexCoord2sv ( GLenum target, const GLshort *v )
{
  glMultiTexCoord2sv (target, v) ;
}
void gst_opengl_glMultiTexCoord3dv ( GLenum target, const GLdouble *v )
{
  glMultiTexCoord3dv (target, v) ;
}
void gst_opengl_glMultiTexCoord3fv ( GLenum target, const GLfloat *v )
{
  glMultiTexCoord3fv (target, v) ;
}
void gst_opengl_glMultiTexCoord3iv ( GLenum target, const GLint *v )
{
  glMultiTexCoord3iv (target, v) ;
}
void gst_opengl_glMultiTexCoord3sv ( GLenum target, const GLshort *v )
{
  glMultiTexCoord3sv (target, v) ;
}
void gst_opengl_glMultiTexCoord4dv ( GLenum target, const GLdouble *v )
{
  glMultiTexCoord4dv (target, v) ;
}
void gst_opengl_glMultiTexCoord4fv ( GLenum target, const GLfloat *v )
{
  glMultiTexCoord4fv (target, v) ;
}
void gst_opengl_glMultiTexCoord4iv ( GLenum target, const GLint *v )
{
  glMultiTexCoord4iv (target, v) ;
}
void gst_opengl_glMultiTexCoord4sv ( GLenum target, const GLshort *v )
{
  glMultiTexCoord4sv (target, v) ;
}
void gst_opengl_glLoadTransposeMatrixd ( const GLdouble m[16] )
{
  glLoadTransposeMatrixd (m) ;
}
void gst_opengl_glLoadTransposeMatrixf ( const GLfloat m[16] )
{
  glLoadTransposeMatrixf (m) ;
}
void gst_opengl_glMultTransposeMatrixd ( const GLdouble m[16] )
{
  glMultTransposeMatrixd (m) ;
}
void gst_opengl_glMultTransposeMatrixf ( const GLfloat m[16] )
{
  glMultTransposeMatrixf (m) ;
}
void gst_opengl_glMultiTexCoord1dvARB (GLenum target, const GLdouble *v)
{
  glMultiTexCoord1dvARB (target, v) ;
}
void gst_opengl_glMultiTexCoord1fvARB (GLenum target, const GLfloat *v)
{
  glMultiTexCoord1fvARB (target, v) ;
}
void gst_opengl_glMultiTexCoord1ivARB (GLenum target, const GLint *v)
{
  glMultiTexCoord1ivARB (target, v) ;
}
void gst_opengl_glMultiTexCoord1svARB (GLenum target, const GLshort *v)
{
  glMultiTexCoord1svARB (target, v) ;
}
void gst_opengl_glMultiTexCoord2dvARB (GLenum target, const GLdouble *v)
{
  glMultiTexCoord2dvARB (target, v) ;
}
void gst_opengl_glMultiTexCoord2fvARB (GLenum target, const GLfloat *v)
{
  glMultiTexCoord2fvARB (target, v) ;
}
void gst_opengl_glMultiTexCoord2ivARB (GLenum target, const GLint *v)
{
  glMultiTexCoord2ivARB (target, v) ;
}
void gst_opengl_glMultiTexCoord2svARB (GLenum target, const GLshort *v)
{
  glMultiTexCoord2svARB (target, v) ;
}
void gst_opengl_glMultiTexCoord3dvARB (GLenum target, const GLdouble *v)
{
  glMultiTexCoord3dvARB (target, v) ;
}
void gst_opengl_glMultiTexCoord3fvARB (GLenum target, const GLfloat *v)
{
  glMultiTexCoord3fvARB (target, v) ;
}
void gst_opengl_glMultiTexCoord3ivARB (GLenum target, const GLint *v)
{
  glMultiTexCoord3ivARB (target, v) ;
}
void gst_opengl_glMultiTexCoord3svARB (GLenum target, const GLshort *v)
{
  glMultiTexCoord3svARB (target, v) ;
}
void gst_opengl_glMultiTexCoord4dvARB (GLenum target, const GLdouble *v)
{
  glMultiTexCoord4dvARB (target, v) ;
}
void gst_opengl_glMultiTexCoord4fvARB (GLenum target, const GLfloat *v)
{
  glMultiTexCoord4fvARB (target, v) ;
}
void gst_opengl_glMultiTexCoord4ivARB (GLenum target, const GLint *v)
{
  glMultiTexCoord4ivARB (target, v) ;
}
void gst_opengl_glMultiTexCoord4svARB (GLenum target, const GLshort *v)
{
  glMultiTexCoord4svARB (target, v) ;
}
void gst_opengl_glNewTraceMESA ( GLbitfield mask, const GLubyte * traceName )
{
  glNewTraceMESA (mask, traceName) ;
}
void gst_opengl_glTraceCommentMESA ( const GLubyte * comment )
{
  glTraceCommentMESA (comment) ;
}
void gst_opengl_glTraceTextureMESA ( GLuint name, const GLubyte* comment )
{
  glTraceTextureMESA (name, comment) ;
}
void gst_opengl_glTraceListMESA ( GLuint name, const GLubyte* comment )
{
  glTraceListMESA (name, comment) ;
}
void gst_opengl_glTracePointerMESA ( GLvoid* pointer, const GLubyte* comment )
{
  glTracePointerMESA (pointer, comment) ;
}
void gst_opengl_glTracePointerRangeMESA ( const GLvoid* first, const GLvoid* last, const GLubyte* comment )
{
  glTracePointerRangeMESA (first, last, comment) ;
}
void gst_opengl_glProgramCallbackMESA (GLenum target, GLprogramcallbackMESA callback, GLvoid *data)
{
  glProgramCallbackMESA (target, callback, data) ;
}
void gst_opengl_glGetProgramRegisterfvMESA (GLenum target, GLsizei len, const GLubyte *name, GLfloat *v)
{
  glGetProgramRegisterfvMESA (target, len, name, v) ;
}
void gst_opengl_glGetQueryObjecti64vEXT (GLuint id, GLenum pname, GLint64EXT *params)
{
  glGetQueryObjecti64vEXT (id, pname, params) ;
}
void gst_opengl_glGetQueryObjectui64vEXT (GLuint id, GLenum pname, GLuint64EXT *params)
{
  glGetQueryObjectui64vEXT (id, pname, params) ;
}
void gst_initModule_gl(VMProxy* proxy) {
/*   proxy->defineCFunc ("glClearIndex", glClearIndex) ; */
  proxy->defineCFunc ("glClearColor", glClearColor) ;
  proxy->defineCFunc ("glClear", glClear) ; 
/*   proxy->defineCFunc ("glIndexMask", glIndexMask) ; */
/*   proxy->defineCFunc ("glColorMask", glColorMask) ; */
/*   proxy->defineCFunc ("glAlphaFunc", glAlphaFunc) ; */
/*   proxy->defineCFunc ("glBlendFunc", glBlendFunc) ; */
/*   proxy->defineCFunc ("glLogicOp", glLogicOp) ; */
/*   proxy->defineCFunc ("glCullFace", glCullFace) ; */
/*   proxy->defineCFunc ("glFrontFace", glFrontFace) ; */
  proxy->defineCFunc ("glPointSize", glPointSize) ;
/*   proxy->defineCFunc ("glLineWidth", glLineWidth) ; */
/*   proxy->defineCFunc ("glLineStipple", glLineStipple) ; */
/*   proxy->defineCFunc ("glPolygonMode", glPolygonMode) ; */
/*   proxy->defineCFunc ("glPolygonOffset", glPolygonOffset) ; */
/*   proxy->defineCFunc ("glPolygonStipple", gst_opengl_glPolygonStipple) ; */
/*   proxy->defineCFunc ("glGetPolygonStipple", gst_opengl_glGetPolygonStipple) ; */
/*   proxy->defineCFunc ("glEdgeFlag", glEdgeFlag) ; */
/*   proxy->defineCFunc ("glEdgeFlagv", gst_opengl_glEdgeFlagv) ; */
/*   proxy->defineCFunc ("glScissor", glScissor) ; */
/*   proxy->defineCFunc ("glClipPlane", gst_opengl_glClipPlane) ; */
/*   proxy->defineCFunc ("glGetClipPlane", gst_opengl_glGetClipPlane) ; */
/*   proxy->defineCFunc ("glDrawBuffer", glDrawBuffer) ; */
/*   proxy->defineCFunc ("glReadBuffer", glReadBuffer) ; */
  proxy->defineCFunc ("glEnable", glEnable) ;
  proxy->defineCFunc ("glDisable", glDisable) ;
  proxy->defineCFunc ("glIsEnabled", glIsEnabled) ;
/*   proxy->defineCFunc ("glEnableClientState", glEnableClientState) ; */
/*   proxy->defineCFunc ("glDisableClientState", glDisableClientState) ; */
/*   proxy->defineCFunc ("glGetBooleanv", gst_opengl_glGetBooleanv) ; */
/*   proxy->defineCFunc ("glGetDoublev", gst_opengl_glGetDoublev) ; */
/*   proxy->defineCFunc ("glGetFloatv", gst_opengl_glGetFloatv) ; */
/*   proxy->defineCFunc ("glGetIntegerv", gst_opengl_glGetIntegerv) ; */
/*   proxy->defineCFunc ("glPushAttrib", glPushAttrib) ; */
/*   proxy->defineCFunc ("glPopAttrib", glPopAttrib) ; */
/*   proxy->defineCFunc ("glPushClientAttrib", glPushClientAttrib) ; */
/*   proxy->defineCFunc ("glPopClientAttrib", glPopClientAttrib) ; */
/*   proxy->defineCFunc ("glRenderMode", glRenderMode) ; */
/*   proxy->defineCFunc ("glGetError", glGetError) ; */
  proxy->defineCFunc ("glFinish", glFinish) ;
  proxy->defineCFunc ("glFlush", glFlush) ; 
/*   proxy->defineCFunc ("glHint", glHint) ; */
/*   proxy->defineCFunc ("glClearDepth", glClearDepth) ; */
/*   proxy->defineCFunc ("glDepthFunc", glDepthFunc) ; */
/*   proxy->defineCFunc ("glDepthMask", glDepthMask) ; */
/*   proxy->defineCFunc ("glDepthRange", glDepthRange) ; */
/*   proxy->defineCFunc ("glClearAccum", glClearAccum) ; */
/*   proxy->defineCFunc ("glAccum", glAccum) ; */
  proxy->defineCFunc ("glMatrixMode", glMatrixMode) ;
  proxy->defineCFunc ("glOrtho", glOrtho) ;
  proxy->defineCFunc ("glFrustum", glFrustum) ;
  proxy->defineCFunc ("glViewport", glViewport) ;
  proxy->defineCFunc ("glPushMatrix", glPushMatrix) ; 
  proxy->defineCFunc ("glPopMatrix", glPopMatrix) ;
  proxy->defineCFunc ("glLoadIdentity", glLoadIdentity) ;
/*   proxy->defineCFunc ("glLoadMatrixd", gst_opengl_glLoadMatrixd) ; */
/*   proxy->defineCFunc ("glLoadMatrixf", gst_opengl_glLoadMatrixf) ; */
/*   proxy->defineCFunc ("glMultMatrixd", gst_opengl_glMultMatrixd) ; */
/*   proxy->defineCFunc ("glMultMatrixf", gst_opengl_glMultMatrixf) ; */
  proxy->defineCFunc ("glRotated", glRotated) ;
  proxy->defineCFunc ("glRotatef", glRotatef) ;
/*   proxy->defineCFunc ("glScaled", glScaled) ; */
  proxy->defineCFunc ("glScalef", glScalef) ;
  proxy->defineCFunc ("glTranslated", glTranslated) ;
  proxy->defineCFunc ("glTranslatef", glTranslatef) ;
  proxy->defineCFunc ("glIsList", glIsList) ;
  proxy->defineCFunc ("glDeleteLists", glDeleteLists) ;
  proxy->defineCFunc ("glGenLists", glGenLists) ;
  proxy->defineCFunc ("glNewList", glNewList) ;
  proxy->defineCFunc ("glEndList", glEndList) ;
  proxy->defineCFunc ("glCallList", glCallList) ; 
  proxy->defineCFunc ("glCallLists", gst_opengl_glCallLists) ; 
  proxy->defineCFunc ("glListBase", glListBase) ; 
  proxy->defineCFunc ("glBegin", glBegin) ;
  proxy->defineCFunc ("glEnd", glEnd) ; 
/*   proxy->defineCFunc ("glVertex2d", glVertex2d) ;  */
/*   proxy->defineCFunc ("glVertex2f", glVertex2f) ;  */
/*   proxy->defineCFunc ("glVertex2i", glVertex2i) ;  */
/*   proxy->defineCFunc ("glVertex2s", glVertex2s) ;  */
/*   proxy->defineCFunc ("glVertex3d", glVertex3d) ;  */
  proxy->defineCFunc ("glVertex3f", glVertex3f) ;
/*   proxy->defineCFunc ("glVertex3i", glVertex3i) ; */
/*   proxy->defineCFunc ("glVertex3s", glVertex3s) ;  */
/*   proxy->defineCFunc ("glVertex4d", glVertex4d) ;  */
/*   proxy->defineCFunc ("glVertex4f", glVertex4f) ;  */
/*   proxy->defineCFunc ("glVertex4i", glVertex4i) ;  */
/*   proxy->defineCFunc ("glVertex4s", glVertex4s) ;  */
/*   proxy->defineCFunc ("glVertex2dv", gst_opengl_glVertex2dv) ; */
/*   proxy->defineCFunc ("glVertex2fv", gst_opengl_glVertex2fv) ; */
/*   proxy->defineCFunc ("glVertex2iv", gst_opengl_glVertex2iv) ; */
/*   proxy->defineCFunc ("glVertex2sv", gst_opengl_glVertex2sv) ; */
/*   proxy->defineCFunc ("glVertex3dv", gst_opengl_glVertex3dv) ; */
/*   proxy->defineCFunc ("glVertex3fv", gst_opengl_glVertex3fv) ; */
/*   proxy->defineCFunc ("glVertex3iv", gst_opengl_glVertex3iv) ; */
/*   proxy->defineCFunc ("glVertex3sv", gst_opengl_glVertex3sv) ; */
/*   proxy->defineCFunc ("glVertex4dv", gst_opengl_glVertex4dv) ; */
/*   proxy->defineCFunc ("glVertex4fv", gst_opengl_glVertex4fv) ; */
/*   proxy->defineCFunc ("glVertex4iv", gst_opengl_glVertex4iv) ; */
/*   proxy->defineCFunc ("glVertex4sv", gst_opengl_glVertex4sv) ; */
/*   proxy->defineCFunc ("glNormal3b", glNormal3b) ; */
/*   proxy->defineCFunc ("glNormal3d", glNormal3d) ; */
/*   proxy->defineCFunc ("glNormal3f", glNormal3f) ; */
/*   proxy->defineCFunc ("glNormal3i", glNormal3i) ; */
/*   proxy->defineCFunc ("glNormal3s", glNormal3s) ; */
/*   proxy->defineCFunc ("glNormal3bv", gst_opengl_glNormal3bv) ; */
/*   proxy->defineCFunc ("glNormal3dv", gst_opengl_glNormal3dv) ; */
/*   proxy->defineCFunc ("glNormal3fv", gst_opengl_glNormal3fv) ; */
/*   proxy->defineCFunc ("glNormal3iv", gst_opengl_glNormal3iv) ; */
/*   proxy->defineCFunc ("glNormal3sv", gst_opengl_glNormal3sv) ; */
/*   proxy->defineCFunc ("glIndexd", glIndexd) ; */
/*   proxy->defineCFunc ("glIndexf", glIndexf) ; */
/*   proxy->defineCFunc ("glIndexi", glIndexi) ; */
/*   proxy->defineCFunc ("glIndexs", glIndexs) ; */
/*   proxy->defineCFunc ("glIndexub", glIndexub) ; */
/*   proxy->defineCFunc ("glIndexdv", gst_opengl_glIndexdv) ; */
/*   proxy->defineCFunc ("glIndexfv", gst_opengl_glIndexfv) ; */
/*   proxy->defineCFunc ("glIndexiv", gst_opengl_glIndexiv) ; */
/*   proxy->defineCFunc ("glIndexsv", gst_opengl_glIndexsv) ; */
/*   proxy->defineCFunc ("glIndexubv", gst_opengl_glIndexubv) ; */
/*   proxy->defineCFunc ("glColor3b", glColor3b) ; */
/*   proxy->defineCFunc ("glColor3d", glColor3d) ; */
  proxy->defineCFunc ("glColor3f", glColor3f) ;
/*   proxy->defineCFunc ("glColor3i", glColor3i) ; */
/*   proxy->defineCFunc ("glColor3s", glColor3s) ; */
/*   proxy->defineCFunc ("glColor3ub", glColor3ub) ; */
/*   proxy->defineCFunc ("glColor3ui", glColor3ui) ; */
/*   proxy->defineCFunc ("glColor3us", glColor3us) ; */
/*   proxy->defineCFunc ("glColor3bv", gst_opengl_glColor3bv) ; */
/*   proxy->defineCFunc ("glColor3dv", gst_opengl_glColor3dv) ; */
/*   proxy->defineCFunc ("glColor3fv", gst_opengl_glColor3fv) ; */
/*   proxy->defineCFunc ("glColor3iv", gst_opengl_glColor3iv) ; */
/*   proxy->defineCFunc ("glColor3sv", gst_opengl_glColor3sv) ; */
/*   proxy->defineCFunc ("glColor3ubv", gst_opengl_glColor3ubv) ; */
/*   proxy->defineCFunc ("glColor3uiv", gst_opengl_glColor3uiv) ; */
/*   proxy->defineCFunc ("glColor3usv", gst_opengl_glColor3usv) ; */
/*   proxy->defineCFunc ("glColor4bv", gst_opengl_glColor4bv) ; */
/*   proxy->defineCFunc ("glColor4dv", gst_opengl_glColor4dv) ; */
/*   proxy->defineCFunc ("glColor4fv", gst_opengl_glColor4fv) ; */
/*   proxy->defineCFunc ("glColor4iv", gst_opengl_glColor4iv) ; */
/*   proxy->defineCFunc ("glColor4sv", gst_opengl_glColor4sv) ; */
/*   proxy->defineCFunc ("glColor4ubv", gst_opengl_glColor4ubv) ; */
/*   proxy->defineCFunc ("glColor4uiv", gst_opengl_glColor4uiv) ; */
/*   proxy->defineCFunc ("glColor4usv", gst_opengl_glColor4usv) ; */
/*   proxy->defineCFunc ("glTexCoord1d", glTexCoord1d) ; */
/*   proxy->defineCFunc ("glTexCoord1f", glTexCoord1f) ; */
/*   proxy->defineCFunc ("glTexCoord1i", glTexCoord1i) ; */
/*   proxy->defineCFunc ("glTexCoord1s", glTexCoord1s) ; */
/*   proxy->defineCFunc ("glTexCoord2d", glTexCoord2d) ; */
/*   proxy->defineCFunc ("glTexCoord2f", glTexCoord2f) ; */
/*   proxy->defineCFunc ("glTexCoord2i", glTexCoord2i) ; */
/*   proxy->defineCFunc ("glTexCoord2s", glTexCoord2s) ; */
/*   proxy->defineCFunc ("glTexCoord3d", glTexCoord3d) ; */
/*   proxy->defineCFunc ("glTexCoord3f", glTexCoord3f) ; */
/*   proxy->defineCFunc ("glTexCoord3i", glTexCoord3i) ; */
/*   proxy->defineCFunc ("glTexCoord3s", glTexCoord3s) ; */
/*   proxy->defineCFunc ("glTexCoord4d", glTexCoord4d) ; */
/*   proxy->defineCFunc ("glTexCoord4f", glTexCoord4f) ; */
/*   proxy->defineCFunc ("glTexCoord4i", glTexCoord4i) ; */
/*   proxy->defineCFunc ("glTexCoord4s", glTexCoord4s) ; */
/*   proxy->defineCFunc ("glTexCoord1dv", gst_opengl_glTexCoord1dv) ; */
/*   proxy->defineCFunc ("glTexCoord1fv", gst_opengl_glTexCoord1fv) ; */
/*   proxy->defineCFunc ("glTexCoord1iv", gst_opengl_glTexCoord1iv) ; */
/*   proxy->defineCFunc ("glTexCoord1sv", gst_opengl_glTexCoord1sv) ; */
/*   proxy->defineCFunc ("glTexCoord2dv", gst_opengl_glTexCoord2dv) ; */
/*   proxy->defineCFunc ("glTexCoord2fv", gst_opengl_glTexCoord2fv) ; */
/*   proxy->defineCFunc ("glTexCoord2iv", gst_opengl_glTexCoord2iv) ; */
/*   proxy->defineCFunc ("glTexCoord2sv", gst_opengl_glTexCoord2sv) ; */
/*   proxy->defineCFunc ("glTexCoord3dv", gst_opengl_glTexCoord3dv) ; */
/*   proxy->defineCFunc ("glTexCoord3fv", gst_opengl_glTexCoord3fv) ; */
/*   proxy->defineCFunc ("glTexCoord3iv", gst_opengl_glTexCoord3iv) ; */
/*   proxy->defineCFunc ("glTexCoord3sv", gst_opengl_glTexCoord3sv) ; */
/*   proxy->defineCFunc ("glTexCoord4dv", gst_opengl_glTexCoord4dv) ; */
/*   proxy->defineCFunc ("glTexCoord4fv", gst_opengl_glTexCoord4fv) ; */
/*   proxy->defineCFunc ("glTexCoord4iv", gst_opengl_glTexCoord4iv) ; */
/*   proxy->defineCFunc ("glTexCoord4sv", gst_opengl_glTexCoord4sv) ; */
/*   proxy->defineCFunc ("glRasterPos2d", glRasterPos2d) ; */
/*   proxy->defineCFunc ("glRasterPos2f", glRasterPos2f) ; */
/*   proxy->defineCFunc ("glRasterPos2i", glRasterPos2i) ; */
/*   proxy->defineCFunc ("glRasterPos2s", glRasterPos2s) ; */
/*   proxy->defineCFunc ("glRasterPos3d", glRasterPos3d) ; */
/*   proxy->defineCFunc ("glRasterPos3f", glRasterPos3f) ; */
/*   proxy->defineCFunc ("glRasterPos3i", glRasterPos3i) ; */
/*   proxy->defineCFunc ("glRasterPos3s", glRasterPos3s) ; */
/*   proxy->defineCFunc ("glRasterPos4d", glRasterPos4d) ; */
/*   proxy->defineCFunc ("glRasterPos4f", glRasterPos4f) ; */
/*   proxy->defineCFunc ("glRasterPos4i", glRasterPos4i) ; */
/*   proxy->defineCFunc ("glRasterPos4s", glRasterPos4s) ; */
/*   proxy->defineCFunc ("glRasterPos2dv", gst_opengl_glRasterPos2dv) ; */
/*   proxy->defineCFunc ("glRasterPos2fv", gst_opengl_glRasterPos2fv) ; */
/*   proxy->defineCFunc ("glRasterPos2iv", gst_opengl_glRasterPos2iv) ; */
/*   proxy->defineCFunc ("glRasterPos2sv", gst_opengl_glRasterPos2sv) ; */
/*   proxy->defineCFunc ("glRasterPos3dv", gst_opengl_glRasterPos3dv) ; */
/*   proxy->defineCFunc ("glRasterPos3fv", gst_opengl_glRasterPos3fv) ; */
/*   proxy->defineCFunc ("glRasterPos3iv", gst_opengl_glRasterPos3iv) ; */
/*   proxy->defineCFunc ("glRasterPos3sv", gst_opengl_glRasterPos3sv) ; */
/*   proxy->defineCFunc ("glRasterPos4dv", gst_opengl_glRasterPos4dv) ; */
/*   proxy->defineCFunc ("glRasterPos4fv", gst_opengl_glRasterPos4fv) ; */
/*   proxy->defineCFunc ("glRasterPos4iv", gst_opengl_glRasterPos4iv) ; */
/*   proxy->defineCFunc ("glRasterPos4sv", gst_opengl_glRasterPos4sv) ; */
/*   proxy->defineCFunc ("glRectd", glRectd) ; */
/*   proxy->defineCFunc ("glRectf", glRectf) ; */
/*   proxy->defineCFunc ("glRecti", glRecti) ; */
/*   proxy->defineCFunc ("glRects", glRects) ; */
/*   proxy->defineCFunc ("glRectdv", gst_opengl_glRectdv) ; */
/*   proxy->defineCFunc ("glRectfv", gst_opengl_glRectfv) ; */
/*   proxy->defineCFunc ("glRectiv", gst_opengl_glRectiv) ; */
/*   proxy->defineCFunc ("glRectsv", gst_opengl_glRectsv) ; */
/*   proxy->defineCFunc ("glEdgeFlagPointer", gst_opengl_glEdgeFlagPointer) ; */
/*   proxy->defineCFunc ("glGetPointerv", gst_opengl_glGetPointerv) ; */
/*   proxy->defineCFunc ("glArrayElement", glArrayElement) ; */
/*   proxy->defineCFunc ("glDrawArrays", glDrawArrays) ; */
  proxy->defineCFunc ("glShadeModel", glShadeModel) ;
/*   proxy->defineCFunc ("glLightf", glLightf) ; */
/*   proxy->defineCFunc ("glLighti", glLighti) ; */
  proxy->defineCFunc ("glLightfv", gst_opengl_glLightfv) ;
/*   proxy->defineCFunc ("glLightiv", gst_opengl_glLightiv) ; */
/*   proxy->defineCFunc ("glGetLightfv", gst_opengl_glGetLightfv) ; */
/*   proxy->defineCFunc ("glGetLightiv", gst_opengl_glGetLightiv) ; */
/*   proxy->defineCFunc ("glLightModelf", glLightModelf) ; */
/*   proxy->defineCFunc ("glLightModeli", glLightModeli) ; */
/*   proxy->defineCFunc ("glLightModelfv", gst_opengl_glLightModelfv) ; */
/*   proxy->defineCFunc ("glLightModeliv", gst_opengl_glLightModeliv) ; */
  proxy->defineCFunc ("glMaterialf", glMaterialf) ;
/*   proxy->defineCFunc ("glMateriali", glMateriali) ; */
  proxy->defineCFunc ("glMaterialfv", gst_opengl_glMaterialfv) ;
/*   proxy->defineCFunc ("glMaterialiv", gst_opengl_glMaterialiv) ; */
/*   proxy->defineCFunc ("glGetMaterialfv", gst_opengl_glGetMaterialfv) ; */
/*   proxy->defineCFunc ("glGetMaterialiv", gst_opengl_glGetMaterialiv) ; */
  proxy->defineCFunc ("glColorMaterial", glColorMaterial) ;
/*   proxy->defineCFunc ("glPixelZoom", glPixelZoom) ; */
/*   proxy->defineCFunc ("glPixelStoref", glPixelStoref) ; */
/*   proxy->defineCFunc ("glPixelStorei", glPixelStorei) ; */
/*   proxy->defineCFunc ("glPixelTransferf", glPixelTransferf) ; */
/*   proxy->defineCFunc ("glPixelTransferi", glPixelTransferi) ; */
/*   proxy->defineCFunc ("glGetPixelMapfv", gst_opengl_glGetPixelMapfv) ; */
/*   proxy->defineCFunc ("glGetPixelMapuiv", gst_opengl_glGetPixelMapuiv) ; */
/*   proxy->defineCFunc ("glGetPixelMapusv", gst_opengl_glGetPixelMapusv) ; */
/*   proxy->defineCFunc ("glStencilFunc", glStencilFunc) ; */
/*   proxy->defineCFunc ("glStencilMask", glStencilMask) ; */
/*   proxy->defineCFunc ("glStencilOp", glStencilOp) ; */
/*   proxy->defineCFunc ("glClearStencil", glClearStencil) ; */
/*   proxy->defineCFunc ("glTexGend", glTexGend) ; */
/*   proxy->defineCFunc ("glTexGenf", glTexGenf) ; */
/*   proxy->defineCFunc ("glTexGeni", glTexGeni) ; */
/*   proxy->defineCFunc ("glTexGendv", gst_opengl_glTexGendv) ; */
/*   proxy->defineCFunc ("glTexGenfv", gst_opengl_glTexGenfv) ; */
/*   proxy->defineCFunc ("glTexGeniv", gst_opengl_glTexGeniv) ; */
/*   proxy->defineCFunc ("glGetTexGendv", gst_opengl_glGetTexGendv) ; */
/*   proxy->defineCFunc ("glGetTexGenfv", gst_opengl_glGetTexGenfv) ; */
/*   proxy->defineCFunc ("glGetTexGeniv", gst_opengl_glGetTexGeniv) ; */
/*   proxy->defineCFunc ("glTexEnvf", glTexEnvf) ; */
/*   proxy->defineCFunc ("glTexEnvi", glTexEnvi) ; */
/*   proxy->defineCFunc ("glTexEnvfv", gst_opengl_glTexEnvfv) ; */
/*   proxy->defineCFunc ("glTexEnviv", gst_opengl_glTexEnviv) ; */
/*   proxy->defineCFunc ("glGetTexEnvfv", gst_opengl_glGetTexEnvfv) ; */
/*   proxy->defineCFunc ("glGetTexEnviv", gst_opengl_glGetTexEnviv) ; */
/*   proxy->defineCFunc ("glTexParameterf", gst_opengl_glTexParameterf) ; */
/*   proxy->defineCFunc ("glTexParameteri", glTexParameteri) ; */
/*   proxy->defineCFunc ("glGenTextures", gst_opengl_glGenTextures) ; */
/*   proxy->defineCFunc ("glDeleteTextures", gst_opengl_glDeleteTextures) ; */
/*   proxy->defineCFunc ("glBindTexture", glBindTexture) ; */
/*   proxy->defineCFunc ("glIsTexture", glIsTexture) ; */
  proxy->defineCFunc("glTexSubImage1D", gst_opengl_glTexSubImage1D) ;
  proxy->defineCFunc("glTexSubImage2D", gst_opengl_glTexSubImage2D) ;
  proxy->defineCFunc("glCopyTexImage1D", glCopyTexImage1D) ;
  proxy->defineCFunc("glCopyTexImage2D", glCopyTexImage2D) ;
  proxy->defineCFunc("glCopyTexSubImage1D", glCopyTexSubImage1D) ;
  proxy->defineCFunc("glCopyTexSubImage2D", glCopyTexSubImage2D) ;
  proxy->defineCFunc("glMap1d", gst_opengl_glMap1d) ;
  proxy->defineCFunc("glMap1f", gst_opengl_glMap1f) ;
  proxy->defineCFunc("glMap2d", gst_opengl_glMap2d) ;
  proxy->defineCFunc("glMap2f", gst_opengl_glMap2f) ;
/*   proxy->defineCFunc ("glGetMapdv", gst_opengl_glGetMapdv) ; */
/*   proxy->defineCFunc ("glGetMapfv", gst_opengl_glGetMapfv) ; */
/*   proxy->defineCFunc ("glGetMapiv", gst_opengl_glGetMapiv) ; */
/*   proxy->defineCFunc ("glEvalCoord1d", glEvalCoord1d) ; */
/*   proxy->defineCFunc ("glEvalCoord1f", glEvalCoord1f) ; */
/*   proxy->defineCFunc ("glEvalCoord1dv", gst_opengl_glEvalCoord1dv) ; */
/*   proxy->defineCFunc ("glEvalCoord1fv", gst_opengl_glEvalCoord1fv) ; */
/*   proxy->defineCFunc ("glEvalCoord2d", glEvalCoord2d) ; */
  proxy->defineCFunc ("glEvalCoord2f", glEvalCoord2f) ;
/*   proxy->defineCFunc ("glEvalCoord2dv", gst_opengl_glEvalCoord2dv) ; */
/*   proxy->defineCFunc ("glEvalCoord2fv", gst_opengl_glEvalCoord2fv) ; */
   proxy->defineCFunc ("glMapGrid1d", glMapGrid1d) ; 
   proxy->defineCFunc ("glMapGrid1f", glMapGrid1f) ; 
   proxy->defineCFunc ("glMapGrid2d", glMapGrid1d) ; 
   proxy->defineCFunc ("glMapGrid2f", glMapGrid1f) ; 
/*   proxy->defineCFunc ("glEvalPoint1", glEvalPoint1) ; */
/*   proxy->defineCFunc ("glEvalPoint2", glEvalPoint2) ; */
/*   proxy->defineCFunc ("glEvalMesh1", glEvalMesh1) ; */
/*   proxy->defineCFunc ("glEvalMesh2", glEvalMesh2) ; */
/*   proxy->defineCFunc ("glFogf", glFogf) ; */
/*   proxy->defineCFunc ("glFogi", glFogi) ; */
/*   proxy->defineCFunc ("glFogfv", gst_opengl_glFogfv) ; */
/*   proxy->defineCFunc ("glFogiv", gst_opengl_glFogiv) ; */
/*   proxy->defineCFunc ("glFeedbackBuffer", gst_opengl_glFeedbackBuffer) ; */
/*   proxy->defineCFunc ("glPassThrough", glPassThrough) ; */
/*   proxy->defineCFunc ("glSelectBuffer", gst_opengl_glSelectBuffer) ; */
/*   proxy->defineCFunc ("glInitNames", glInitNames) ; */
/*   proxy->defineCFunc ("glLoadName", glLoadName) ; */
/*   proxy->defineCFunc ("glPushName", glPushName) ; */
/*   proxy->defineCFunc ("glPopName", glPopName) ; */
/*   proxy->defineCFunc ("glBlendEquation", glBlendEquation) ; */
/*   proxy->defineCFunc ("glResetHistogram", glResetHistogram) ; */
/*   proxy->defineCFunc ("glResetMinmax", glResetMinmax) ; */
/*   proxy->defineCFunc ("glActiveTexture", glActiveTexture) ; */
/*   proxy->defineCFunc ("glClientActiveTexture", glClientActiveTexture) ; */
/*   proxy->defineCFunc ("glCompressedTexImage1D", gst_opengl_glCompressedTexImage1D) ; */
/*   proxy->defineCFunc ("glCompressedTexImage2D", gst_opengl_glCompressedTexImage2D) ; */
/*   proxy->defineCFunc ("glCompressedTexImage3D", gst_opengl_glCompressedTexImage3D) ; */
/*   proxy->defineCFunc ("glCompressedTexSubImage1D", gst_opengl_glCompressedTexSubImage1D) ; */
/*   proxy->defineCFunc ("glCompressedTexSubImage2D", gst_opengl_glCompressedTexSubImage2D) ; */
/*   proxy->defineCFunc ("glCompressedTexSubImage3D", gst_opengl_glCompressedTexSubImage3D) ; */
/*   proxy->defineCFunc ("glGetCompressedTexImage", gst_opengl_glGetCompressedTexImage) ; */
/*   proxy->defineCFunc ("glMultiTexCoord1d", glMultiTexCoord1d) ; */
/*   proxy->defineCFunc ("glMultiTexCoord1dv", gst_opengl_glMultiTexCoord1dv) ; */
/*   proxy->defineCFunc ("glMultiTexCoord1f", glMultiTexCoord1f) ; */
/*   proxy->defineCFunc ("glMultiTexCoord1fv", gst_opengl_glMultiTexCoord1fv) ; */
/*   proxy->defineCFunc ("glMultiTexCoord1i", glMultiTexCoord1i) ; */
/*   proxy->defineCFunc ("glMultiTexCoord1iv", gst_opengl_glMultiTexCoord1iv) ; */
/*   proxy->defineCFunc ("glMultiTexCoord1s", glMultiTexCoord1s) ; */
/*   proxy->defineCFunc ("glMultiTexCoord1sv", gst_opengl_glMultiTexCoord1sv) ; */
/*   proxy->defineCFunc ("glMultiTexCoord2d", glMultiTexCoord2d) ; */
/*   proxy->defineCFunc ("glMultiTexCoord2dv", gst_opengl_glMultiTexCoord2dv) ; */
/*   proxy->defineCFunc ("glMultiTexCoord2f", glMultiTexCoord2f) ; */
/*   proxy->defineCFunc ("glMultiTexCoord2fv", gst_opengl_glMultiTexCoord2fv) ; */
/*   proxy->defineCFunc ("glMultiTexCoord2i", glMultiTexCoord2i) ; */
/*   proxy->defineCFunc ("glMultiTexCoord2iv", gst_opengl_glMultiTexCoord2iv) ; */
/*   proxy->defineCFunc ("glMultiTexCoord2s", glMultiTexCoord2s) ; */
/*   proxy->defineCFunc ("glMultiTexCoord2sv", gst_opengl_glMultiTexCoord2sv) ; */
/*   proxy->defineCFunc ("glMultiTexCoord3d", glMultiTexCoord3d) ; */
/*   proxy->defineCFunc ("glMultiTexCoord3dv", gst_opengl_glMultiTexCoord3dv) ; */
/*   proxy->defineCFunc ("glMultiTexCoord3f", glMultiTexCoord3f) ; */
/*   proxy->defineCFunc ("glMultiTexCoord3fv", gst_opengl_glMultiTexCoord3fv) ; */
/*   proxy->defineCFunc ("glMultiTexCoord3i", glMultiTexCoord3i) ; */
/*   proxy->defineCFunc ("glMultiTexCoord3iv", gst_opengl_glMultiTexCoord3iv) ; */
/*   proxy->defineCFunc ("glMultiTexCoord3s", glMultiTexCoord3s) ; */
/*   proxy->defineCFunc ("glMultiTexCoord3sv", gst_opengl_glMultiTexCoord3sv) ; */
/*   proxy->defineCFunc ("glMultiTexCoord4d", glMultiTexCoord4d) ; */
/*   proxy->defineCFunc ("glMultiTexCoord4dv", gst_opengl_glMultiTexCoord4dv) ; */
/*   proxy->defineCFunc ("glMultiTexCoord4f", glMultiTexCoord4f) ; */
/*   proxy->defineCFunc ("glMultiTexCoord4fv", gst_opengl_glMultiTexCoord4fv) ; */
/*   proxy->defineCFunc ("glMultiTexCoord4i", glMultiTexCoord4i) ; */
/*   proxy->defineCFunc ("glMultiTexCoord4iv", gst_opengl_glMultiTexCoord4iv) ; */
/*   proxy->defineCFunc ("glMultiTexCoord4s", glMultiTexCoord4s) ; */
/*   proxy->defineCFunc ("glMultiTexCoord4sv", gst_opengl_glMultiTexCoord4sv) ; */
/*   proxy->defineCFunc ("glLoadTransposeMatrixd", gst_opengl_glLoadTransposeMatrixd) ; */
/*   proxy->defineCFunc ("glLoadTransposeMatrixf", gst_opengl_glLoadTransposeMatrixf) ; */
/*   proxy->defineCFunc ("glMultTransposeMatrixd", gst_opengl_glMultTransposeMatrixd) ; */
/*   proxy->defineCFunc ("glMultTransposeMatrixf", gst_opengl_glMultTransposeMatrixf) ; */
/*   proxy->defineCFunc ("glSampleCoverage", glSampleCoverage) ; */
/*   proxy->defineCFunc ("glActiveTextureARB", glActiveTextureARB) ; */
/*   proxy->defineCFunc ("glClientActiveTextureARB", glClientActiveTextureARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord1dARB", glMultiTexCoord1dARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord1dvARB", gst_opengl_glMultiTexCoord1dvARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord1fARB", glMultiTexCoord1fARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord1fvARB", gst_opengl_glMultiTexCoord1fvARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord1iARB", glMultiTexCoord1iARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord1ivARB", gst_opengl_glMultiTexCoord1ivARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord1sARB", glMultiTexCoord1sARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord1svARB", gst_opengl_glMultiTexCoord1svARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord2dARB", glMultiTexCoord2dARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord2dvARB", gst_opengl_glMultiTexCoord2dvARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord2fARB", glMultiTexCoord2fARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord2fvARB", gst_opengl_glMultiTexCoord2fvARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord2iARB", glMultiTexCoord2iARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord2ivARB", gst_opengl_glMultiTexCoord2ivARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord2sARB", glMultiTexCoord2sARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord2svARB", gst_opengl_glMultiTexCoord2svARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord3dARB", glMultiTexCoord3dARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord3dvARB", gst_opengl_glMultiTexCoord3dvARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord3fARB", glMultiTexCoord3fARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord3fvARB", gst_opengl_glMultiTexCoord3fvARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord3iARB", glMultiTexCoord3iARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord3ivARB", gst_opengl_glMultiTexCoord3ivARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord3sARB", glMultiTexCoord3sARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord3svARB", gst_opengl_glMultiTexCoord3svARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord4dARB", glMultiTexCoord4dARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord4dvARB", gst_opengl_glMultiTexCoord4dvARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord4fARB", glMultiTexCoord4fARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord4fvARB", gst_opengl_glMultiTexCoord4fvARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord4iARB", glMultiTexCoord4iARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord4ivARB", gst_opengl_glMultiTexCoord4ivARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord4sARB", glMultiTexCoord4sARB) ; */
/*   proxy->defineCFunc ("glMultiTexCoord4svARB", gst_opengl_glMultiTexCoord4svARB) ; */
/*   proxy->defineCFunc ("glEnableTraceMESA", glEnableTraceMESA) ; */
/*   proxy->defineCFunc ("glDisableTraceMESA", glDisableTraceMESA) ; */
/*   proxy->defineCFunc ("glNewTraceMESA", gst_opengl_glNewTraceMESA) ; */
/*   proxy->defineCFunc ("glEndTraceMESA", glEndTraceMESA) ; */
/*   proxy->defineCFunc ("glTraceAssertAttribMESA", glTraceAssertAttribMESA) ; */
/*   proxy->defineCFunc ("glTraceCommentMESA", gst_opengl_glTraceCommentMESA) ; */
/*   proxy->defineCFunc ("glTraceTextureMESA", gst_opengl_glTraceTextureMESA) ; */
/*   proxy->defineCFunc ("glTraceListMESA", gst_opengl_glTraceListMESA) ; */
/*   proxy->defineCFunc ("glTracePointerMESA", gst_opengl_glTracePointerMESA) ; */
/*   proxy->defineCFunc ("glTracePointerRangeMESA", gst_opengl_glTracePointerRangeMESA) ; */
/*   proxy->defineCFunc ("glProgramCallbackMESA", gst_opengl_glProgramCallbackMESA) ; */
/*   proxy->defineCFunc ("glGetProgramRegisterfvMESA", gst_opengl_glGetProgramRegisterfvMESA) ; */
/*   proxy->defineCFunc ("glBlendEquationSeparateATI", glBlendEquationSeparateATI) ; */
/*   proxy->defineCFunc ("glGetQueryObjecti64vEXT", gst_opengl_glGetQueryObjecti64vEXT) ; */
/*   proxy->defineCFunc ("glGetQueryObjectui64vEXT", gst_opengl_glGetQueryObjectui64vEXT) ; */
  _opengl_vm_proxy = proxy ;
}
