#include "config.h"
#include "gstpub.h"

#include <stdio.h>
#include <GL/glut.h>

static VMProxy* _opengl_vm_proxy = NULL ;
#define nil  _opengl_vm_proxy->nilOOP

extern void gst_init_module_gluNurbs(VMProxy* proxy) ;
extern void gst_init_module_gluTess(VMProxy* proxy) ;

//#define DEBUG 1

#ifdef DEBUG
static FILE* fp = NULL ;
#endif



void gst_opengl_gluBeginCurve (OOP nurb)
{
  gluBeginCurve (_opengl_vm_proxy->OOPToCObject(nurb)) ;
}
void gst_opengl_gluBeginPolygon (OOP tess)
{
	gluBeginPolygon (_opengl_vm_proxy->OOPToCObject(tess)) ;
}
void gst_opengl_gluBeginSurface (OOP nurb)
{
  gluBeginSurface (_opengl_vm_proxy->OOPToCObject(nurb)) ;
}
void gst_opengl_gluBeginTrim (OOP nurb)
{
  gluBeginTrim (_opengl_vm_proxy->OOPToCObject(nurb)) ;
}
GLint gst_opengl_gluBuild1DMipmapLevels (GLenum target, GLint internalFormat, GLsizei width, GLenum format, GLenum type, GLint level, GLint base, GLint max, const void *data)
{
  return gluBuild1DMipmapLevels (target, internalFormat, width, format, type, level, base, max, data) ;
}
GLint gst_opengl_gluBuild1DMipmaps (GLenum target, GLint internalFormat, GLsizei width, GLenum format, GLenum type, const void *data)
{
  return gluBuild1DMipmaps (target, internalFormat, width, format, type, data) ;
}
GLint gst_opengl_gluBuild2DMipmapLevels (GLenum target, GLint internalFormat, GLsizei width, GLsizei height, GLenum format, GLenum type, GLint level, GLint base, GLint max, const void *data)
{
  return gluBuild2DMipmapLevels (target, internalFormat, width, height, format, type, level, base, max, data) ;
}
GLint gst_opengl_gluBuild2DMipmaps (GLenum target, GLint internalFormat, GLsizei width, GLsizei height, GLenum format, GLenum type, const void *data)
{
  return gluBuild2DMipmaps (target, internalFormat, width, height, format, type, data) ;
}
GLint gst_opengl_gluBuild3DMipmapLevels (GLenum target, GLint internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, GLint level, GLint base, GLint max, const void *data)
{
  return gluBuild3DMipmapLevels (target, internalFormat, width, height, depth, format, type, level, base, max, data) ;
}
GLint gst_opengl_gluBuild3DMipmaps (GLenum target, GLint internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const void *data)
{
  return gluBuild3DMipmaps (target, internalFormat, width, height, depth, format, type, data) ;
}
GLboolean gst_opengl_gluCheckExtension (const GLubyte *extName, const GLubyte *extString)
{
  return gluCheckExtension (extName, extString) ;
}
void gst_opengl_gluCylinder (OOP quad, GLdouble base, GLdouble top, GLdouble height, GLint slices, GLint stacks)
{
  gluCylinder (_opengl_vm_proxy->OOPToCObject(quad),
			   base, top, height, slices, stacks) ;
}
void gst_opengl_gluDeleteQuadric (OOP quad)
{
  gluDeleteQuadric (_opengl_vm_proxy->OOPToCObject(quad)) ;
}
void gst_opengl_gluDeleteTess (OOP tess)
{
  gluDeleteTess (_opengl_vm_proxy->OOPToCObject(tess)) ;
}
void gst_opengl_gluDisk (OOP quad, GLdouble inner, GLdouble outer, GLint slices, GLint loops)
{
  gluDisk (_opengl_vm_proxy->OOPToCObject(quad), inner, outer, slices, loops) ;
}
void gst_opengl_gluEndCurve (OOP nurb)
{
  gluEndCurve (_opengl_vm_proxy->OOPToCObject(nurb)) ;
}
void gst_opengl_gluEndPolygon (OOP tess)
{
  gluEndPolygon (_opengl_vm_proxy->OOPToCObject(tess)) ;
}
void gst_opengl_gluEndSurface (OOP nurb)
{
  gluEndSurface (_opengl_vm_proxy->OOPToCObject(nurb)) ;
}
void gst_opengl_gluEndTrim (OOP nurb)
{
  gluEndTrim (_opengl_vm_proxy->OOPToCObject(nurb)) ;
}
GLdouble gst_opengl_gluGetTessProperty (OOP tess, GLenum which)
{
  GLdouble data ;
  gluGetTessProperty (_opengl_vm_proxy->OOPToCObject(tess), which, &data) ;
  return data ;
}
void gst_opengl_gluLoadSamplingMatrices (OOP nurb, OOP modelMatrix, OOP projectionMatrix, OOP viewportVertex)
{
  GLfloat model[16] ;
  GLfloat projection[16] ;
  GLint viewport[4] ;
  size_t nObjs, i ;

  /* Retreive model matrix (4x4) */
  nObjs = _opengl_vm_proxy->OOPSize(modelMatrix) ;
  if(nObjs < 16) 
	return ;					/* Should fire an interrupt */
  for(i = 0 ; i < 16 ; ++i)
	model[i] = _opengl_vm_proxy->OOPToFloat(_opengl_vm_proxy->OOPAt(modelMatrix, i)) ;

  /* Retreive projection matrix (4x4) */
  nObjs = _opengl_vm_proxy->OOPSize(projectionMatrix) ;
  if(nObjs < 16) 
	return ;					/* Should fire an interrupt */
  for(i = 0 ; i < 16 ; ++i)
	projection[i] = _opengl_vm_proxy->OOPToFloat(_opengl_vm_proxy->OOPAt(projectionMatrix, i)) ;

  /* Retreive viewport (4) */
  nObjs = _opengl_vm_proxy->OOPSize(viewportVertex) ;
  if(nObjs < 4) 
	return ;					/* Should fire an interrupt */
  for(i = 0 ; i < 4 ; ++i)
	viewport[i] = _opengl_vm_proxy->OOPToInt(_opengl_vm_proxy->OOPAt(viewportVertex, i)) ;


  gluLoadSamplingMatrices (_opengl_vm_proxy->OOPToCObject(nurb), model, projection, viewport) ;
}

void gst_opengl_gluNextContour (OOP tess, GLenum type)
{
  gluNextContour (_opengl_vm_proxy->OOPToCObject(tess), type) ;
}

void gst_opengl_gluPartialDisk (OOP quad, GLdouble inner, GLdouble outer, GLint slices, GLint loops, GLdouble start, GLdouble sweep)
{
  gluPartialDisk ((GLUquadric*)_opengl_vm_proxy->OOPToCObject (quad), inner, outer, slices, loops, start, sweep) ;
}
void gst_opengl_gluPickMatrix (GLdouble x, GLdouble y, GLdouble delX, GLdouble delY, OOP viewportOO)
{
  int nObjs, i ;
  GLint viewport[4] ;
  nObjs = _opengl_vm_proxy->OOPSize(viewportOO) ;
  if(nObjs != 4)
	return ;					/* Should fire an interrupt */
  for(i = 0 ; i < 4 ; ++i)
	viewport[i] = _opengl_vm_proxy->OOPToInt(_opengl_vm_proxy->OOPAt(viewportOO, i)) ;
  gluPickMatrix (x, y, delX, delY, viewport) ;
}

OOP gst_opengl_gluProject (GLdouble objX, GLdouble objY, GLdouble objZ, const GLdouble *model, const GLdouble *proj, const GLint *view) 
{
  GLdouble winX, winY, winZ ;
  OOP result = nil ;					/* An array of 3 doubles */

  if(GL_TRUE == gluProject (objX, objY, objZ, model, proj, view, &winX, &winY, &winZ))
	{
	  result = _opengl_vm_proxy->objectAlloc(_opengl_vm_proxy->arrayClass, 3) ; /* Create an array of 3 variables */  
	  _opengl_vm_proxy->OOPAtPut(result, 0,
								 _opengl_vm_proxy->longDoubleToOOP(winX)) ;
	  _opengl_vm_proxy->OOPAtPut(result, 1,
								 _opengl_vm_proxy->longDoubleToOOP(winY)) ;
	  _opengl_vm_proxy->OOPAtPut(result, 2,
								 _opengl_vm_proxy->longDoubleToOOP(winZ)) ;
	}
  return result ;
}

void gst_opengl_gluPwlCurve (OOP nurb, GLint count, OOP data, GLint stride, GLenum type)
{
  GLfloat* dataFloat ;
  size_t nObjs = 0 ;
  size_t i ;					/* index */
  /* Retreive data and put them in an array */
  nObjs = _opengl_vm_proxy->OOPSize(data) ;
  if(nObjs < count) 
	return ;					/* Should fire an interrupt */
  dataFloat = alloca (sizeof(GLfloat) * count) ;
  for(i = 0 ; i < count ; ++i)
	dataFloat[i] = _opengl_vm_proxy->OOPToFloat(_opengl_vm_proxy->OOPAt(data, i)) ;

  gluPwlCurve (_opengl_vm_proxy->OOPToCObject(nurb),
			   count,
			   dataFloat,
			   stride, 
			   type) ;
}
void gst_opengl_gluQuadricCallback (OOP quad, GLenum which, _GLUfuncptr CallBackFunc)
{
  gluQuadricCallback ((GLUquadric*) _opengl_vm_proxy->OOPToCObject(quad), which, CallBackFunc) ;
}
void gst_opengl_gluQuadricDrawStyle (OOP quad, GLenum draw)
{
  gluQuadricDrawStyle ((GLUquadric*) _opengl_vm_proxy->OOPToCObject(quad), draw) ;
}
void gst_opengl_gluQuadricNormals (OOP quad, GLenum normal)
{
  gluQuadricNormals ((GLUquadric*) _opengl_vm_proxy->OOPToCObject(quad), normal) ;
}
void gst_opengl_gluQuadricOrientation (OOP quad, GLenum orientation)
{
  gluQuadricOrientation ((GLUquadric*) _opengl_vm_proxy->OOPToCObject(quad), orientation) ;
}
void gst_opengl_gluQuadricTexture (OOP quad, GLboolean texture)
{
  gluQuadricTexture ((GLUquadric*) _opengl_vm_proxy->OOPToCObject(quad), texture) ;
}
GLint gst_opengl_gluScaleImage (GLenum format, GLsizei wIn, GLsizei hIn, GLenum typeIn, const void *dataIn, GLsizei wOut, GLsizei hOut, GLenum typeOut, GLvoid* dataOut)
{
  
  return gluScaleImage (format, wIn, hIn, typeIn, dataIn, wOut, hOut, typeOut, dataOut) ;
}
void gst_opengl_gluSphere (OOP quad, GLdouble radius, GLint slices, GLint stacks)
{
  gluSphere ((GLUquadric*) _opengl_vm_proxy->OOPToCObject(quad), radius, slices, stacks) ;
}
void gst_opengl_gluTessBeginContour (OOP tess)
{
  gluTessBeginContour ((GLUtesselator*) _opengl_vm_proxy->OOPToCObject(tess)) ;
}
void gst_opengl_gluTessBeginPolygon (OOP tess, GLvoid* data)
{
  gluTessBeginPolygon ((GLUtesselator*) _opengl_vm_proxy->OOPToCObject(tess), data) ;
}

void gst_opengl_gluTessEndContour (OOP tess)
{
  gluTessEndContour ((GLUtesselator*) _opengl_vm_proxy->OOPToCObject(tess)) ;
}
void gst_opengl_gluTessEndPolygon (OOP tess)
{
  gluTessEndPolygon ((GLUtesselator*) _opengl_vm_proxy->OOPToCObject(tess)) ;
}
void gst_opengl_gluTessNormal (OOP tess, GLdouble valueX, GLdouble valueY, GLdouble valueZ)
{
  gluTessNormal ((GLUtesselator*) _opengl_vm_proxy->OOPToCObject(tess), valueX, valueY, valueZ) ;
}
void gst_opengl_gluTessProperty (OOP tess, GLenum which, GLdouble data)
{
  gluTessProperty ((GLUtesselator*) _opengl_vm_proxy->OOPToCObject(tess), which, data) ;
}
void gst_opengl_gluTessVertex (OOP tess, OOP location, OOP data)
{
  GLdouble coords[3] ;
  size_t nObjs, i ;

  /* Retreive coords  */
  nObjs = _opengl_vm_proxy->OOPSize(location) ;
  if(nObjs < 3) 
	return ;				/* Should fire an interrupt */
  for(i = 0 ; i < 3 ; ++i)
	coords[i] = _opengl_vm_proxy->OOPToLongDouble(_opengl_vm_proxy->OOPAt(location, i)) ;
  
  gluTessVertex ((GLUtesselator*) _opengl_vm_proxy->OOPToCObject(tess), 
				 coords, 
				 (void*) _opengl_vm_proxy->OOPToCObject(data)) ;
}

OOP gst_opengl_gluUnProject (GLdouble winX, GLdouble winY, GLdouble winZ, OOP modelMatrix, OOP projectionMatrix, OOP viewportVertex)
{
  GLdouble model[16], projection[16] ;
  GLint viewport[4] ;
  GLdouble objX, objY, objZ ;
  OOP result = nil ;			/* An array of 3 doubles */
  size_t nObjs, i ;

  /* Retreive model matrix (4x4) */
  nObjs = _opengl_vm_proxy->OOPSize(modelMatrix) ;
  if(nObjs < 16) 
	return result ;				/* Should fire an interrupt */
  for(i = 0 ; i < 16 ; ++i)
	model[i] = _opengl_vm_proxy->OOPToFloat(_opengl_vm_proxy->OOPAt(modelMatrix, i)) ;

  /* Retreive projection matrix (4x4) */
  nObjs = _opengl_vm_proxy->OOPSize(projectionMatrix) ;
  if(nObjs < 16) 
	return result ;				/* Should fire an interrupt */
  for(i = 0 ; i < 16 ; ++i)
	projection[i] = _opengl_vm_proxy->OOPToFloat(_opengl_vm_proxy->OOPAt(projectionMatrix, i)) ;

  /* Retreive viewport (4) */
  nObjs = _opengl_vm_proxy->OOPSize(viewportVertex) ;
  if(nObjs < 4) 
	return result ;				/* Should fire an interrupt */
  for(i = 0 ; i < 4 ; ++i)
	viewport[i] = _opengl_vm_proxy->OOPToInt(_opengl_vm_proxy->OOPAt(viewportVertex, i)) ;


  if(GL_TRUE == gluUnProject (winX, winY, winZ, model, projection, viewport, &objX, &objY, &objZ)) 
	{
	  result = _opengl_vm_proxy->objectAlloc(_opengl_vm_proxy->arrayClass, 3) ; /* Create an array of 3 variables */  

	  _opengl_vm_proxy->OOPAtPut(result, 0,
								 _opengl_vm_proxy->longDoubleToOOP(objX)) ;
	  _opengl_vm_proxy->OOPAtPut(result, 1,
								 _opengl_vm_proxy->longDoubleToOOP(objY)) ;
	  _opengl_vm_proxy->OOPAtPut(result, 2,
								 _opengl_vm_proxy->longDoubleToOOP(objZ)) ;
	}
  return result ;
}

OOP gst_opengl_gluUnProject4 (GLdouble winX, GLdouble winY, GLdouble winZ, GLdouble clipW, 
								OOP modelMatrix, OOP projectionMatrix, OOP viewportVertex, 
								GLdouble nearVal, GLdouble farVal)
{
  GLdouble model[16], projection[16] ;
  GLint viewport[4] ;
  GLdouble objX, objY, objZ, objW ;
  OOP result = nil ;			/* An array of 3 doubles */
  size_t nObjs, i ;

  /* Retreive model matrix (4x4) */
  nObjs = _opengl_vm_proxy->OOPSize(modelMatrix) ;
  if(nObjs < 16) 
	return result ;				/* Should fire an interrupt */
  for(i = 0 ; i < 16 ; ++i)
	model[i] = _opengl_vm_proxy->OOPToFloat(_opengl_vm_proxy->OOPAt(modelMatrix, i)) ;

  /* Retreive projection matrix (4x4) */
  nObjs = _opengl_vm_proxy->OOPSize(projectionMatrix) ;
  if(nObjs < 16) 
	return result ;				/* Should fire an interrupt */
  for(i = 0 ; i < 16 ; ++i)
	projection[i] = _opengl_vm_proxy->OOPToFloat(_opengl_vm_proxy->OOPAt(projectionMatrix, i)) ;

  /* Retreive viewport (4) */
  nObjs = _opengl_vm_proxy->OOPSize(viewportVertex) ;
  if(nObjs < 4) 
	return result ;				/* Should fire an interrupt */
  for(i = 0 ; i < 4 ; ++i)
	viewport[i] = _opengl_vm_proxy->OOPToInt(_opengl_vm_proxy->OOPAt(viewportVertex, i)) ;


  if(GL_TRUE == gluUnProject4 (winX, winY, winZ, clipW, model, projection, viewport, nearVal, farVal, &objX, &objY, &objZ, &objW)) 
	{
	  result = _opengl_vm_proxy->objectAlloc(_opengl_vm_proxy->arrayClass, 4) ; /* Create an array of 4 variables */  

	  _opengl_vm_proxy->OOPAtPut(result, 0,
								 _opengl_vm_proxy->longDoubleToOOP(objX)) ;
	  _opengl_vm_proxy->OOPAtPut(result, 1,
								 _opengl_vm_proxy->longDoubleToOOP(objY)) ;
	  _opengl_vm_proxy->OOPAtPut(result, 2,
								 _opengl_vm_proxy->longDoubleToOOP(objZ)) ;
	  _opengl_vm_proxy->OOPAtPut(result, 3,
								 _opengl_vm_proxy->longDoubleToOOP(objW)) ;
	}
  return result ;
}


/* Init module */
void gst_initModule_glu(VMProxy* proxy) {
  _opengl_vm_proxy = proxy ;


#ifdef DEBUG
  if( (fp = fopen("/home/olivier/gst.dbg", "a+")) != NULL) {
	fprintf(fp,  "init module glu\n") ;
	fflush(fp) ;
  }
#endif  

  /* Define C Functions */
  proxy->defineCFunc ("gluBeginCurve", gst_opengl_gluBeginCurve) ;
  proxy->defineCFunc ("gluBeginPolygon", gst_opengl_gluBeginPolygon) ;
  proxy->defineCFunc ("gluBeginSurface", gst_opengl_gluBeginSurface) ;
  proxy->defineCFunc ("gluBeginTrim", gst_opengl_gluBeginTrim) ;
  proxy->defineCFunc ("gluBuild1DMipmapLevels", gst_opengl_gluBuild1DMipmapLevels) ;
  proxy->defineCFunc ("gluBuild1DMipmaps", gst_opengl_gluBuild1DMipmaps) ;
  proxy->defineCFunc ("gluBuild2DMipmapLevels", gst_opengl_gluBuild2DMipmapLevels) ;
  proxy->defineCFunc ("gluBuild2DMipmaps", gst_opengl_gluBuild2DMipmaps) ;
  proxy->defineCFunc ("gluBuild3DMipmapLevels", gst_opengl_gluBuild3DMipmapLevels) ;
  proxy->defineCFunc ("gluBuild3DMipmaps", gst_opengl_gluBuild3DMipmaps) ;
  proxy->defineCFunc ("gluCheckExtension", gst_opengl_gluCheckExtension) ;
  proxy->defineCFunc ("gluCylinder", gst_opengl_gluCylinder) ;
  proxy->defineCFunc ("gluDeleteQuadric", gst_opengl_gluDeleteQuadric) ;
  proxy->defineCFunc ("gluDeleteTess", gst_opengl_gluDeleteTess) ;
  proxy->defineCFunc ("gluDisk", gst_opengl_gluDisk) ;
  proxy->defineCFunc ("gluEndCurve", gst_opengl_gluEndCurve) ;
  proxy->defineCFunc ("gluEndPolygon", gst_opengl_gluEndPolygon) ;
  proxy->defineCFunc ("gluEndSurface", gst_opengl_gluEndSurface) ;
  proxy->defineCFunc ("gluEndTrim", gst_opengl_gluEndTrim) ;
  proxy->defineCFunc ("gluGetTessProperty", gst_opengl_gluGetTessProperty) ;
  proxy->defineCFunc ("gluLoadSamplingMatrices", gst_opengl_gluLoadSamplingMatrices) ;
  proxy->defineCFunc ("gluLookAt", gluLookAt) ;
  proxy->defineCFunc ("gluNextContour", gst_opengl_gluNextContour) ;
  proxy->defineCFunc ("gluOrtho2D", gluOrtho2D) ;
  proxy->defineCFunc ("gluPartialDisk", gst_opengl_gluPartialDisk) ;
  proxy->defineCFunc ("gluPerspective", gluPerspective) ;
  proxy->defineCFunc ("gluPickMatrix", gst_opengl_gluPickMatrix) ;
  proxy->defineCFunc ("gluProject", gst_opengl_gluProject) ;
  proxy->defineCFunc ("gluPwlCurve", gst_opengl_gluPwlCurve) ;
  proxy->defineCFunc ("gluQuadricCallback", gst_opengl_gluQuadricCallback) ;
  proxy->defineCFunc ("gluQuadricDrawStyle", gst_opengl_gluQuadricDrawStyle) ;
  proxy->defineCFunc ("gluQuadricNormals", gst_opengl_gluQuadricNormals) ;
  proxy->defineCFunc ("gluQuadricOrientation", gst_opengl_gluQuadricOrientation) ;
  proxy->defineCFunc ("gluQuadricTexture", gst_opengl_gluQuadricTexture) ;
  proxy->defineCFunc ("gluScaleImage", gst_opengl_gluScaleImage) ;
  proxy->defineCFunc ("gluSphere", gst_opengl_gluSphere) ;
  proxy->defineCFunc ("gluTessBeginContour", gst_opengl_gluTessBeginContour) ;
  proxy->defineCFunc ("gluTessBeginPolygon", gst_opengl_gluTessBeginPolygon) ;
  proxy->defineCFunc ("gluTessEndContour", gst_opengl_gluTessEndContour) ;
  proxy->defineCFunc ("gluTessEndPolygon", gst_opengl_gluTessEndPolygon) ;
  proxy->defineCFunc ("gluTessNormal", gst_opengl_gluTessNormal) ;
  proxy->defineCFunc ("gluTessProperty", gst_opengl_gluTessProperty) ;
  proxy->defineCFunc ("gluTessVertex", gst_opengl_gluTessVertex) ;
  proxy->defineCFunc ("gluUnProject", gst_opengl_gluUnProject) ;
  proxy->defineCFunc ("gluUnProject4", gst_opengl_gluUnProject4) ;

#ifdef DEBUG
  if( fp != NULL) {
	fprintf(fp, "Calling Nurbs init\n") ;
	fflush(fp) ;
  }
#endif  
  gst_init_module_gluNurbs(proxy) ;
  gst_init_module_gluTess(proxy) ;

#ifdef DEBUG
  if( fp != NULL) {
	fprintf(fp, "Glu init Done\n") ;
	fflush(fp) ;
	fclose(fp) ;
	fp = NULL ;
  }
#endif  
}
