#include "config.h"
#include "gstpub.h"

#include <stdio.h>
#include <GL/glut.h>


static VMProxy* _opengl_vm_proxy = NULL ;
#define nil  _opengl_vm_proxy->nilOOP

/* glut.h */

void gst_opengl_glutInit( char* argv ) 
{
  int pargc = 1 ;
  char *v[2] = {argv, NULL} ;
  glutInit( &pargc, v );
}

int gst_opengl_glutCreateMenu( void (* callback)( int menu ) )
{
  return glutCreateMenu( callback ) ;
}

void gst_opengl_glutTimerFunc( unsigned int time, void (* callback)( int ), int value )
{
  glutTimerFunc( time, callback, value ) ;
}

void gst_opengl_glutIdleFunc( void (* callback)( void ) )
{
  glutIdleFunc( callback ) ;
}


void gst_opengl_glutBitmapCharacter( void* font, int character )
{
  glutBitmapCharacter( font, character ) ;
}

int gst_opengl_glutBitmapWidth( void* font, int character )
{
  return glutBitmapWidth( font, character ) ;
}

void gst_opengl_glutStrokeCharacter( void* font, int character )
{
  glutStrokeCharacter( font, character ) ;
}

int gst_opengl_glutStrokeWidth( void* font, int character )
{
  return glutStrokeWidth( font, character ) ;
}

int gst_opengl_glutBitmapLength( void* font, const unsigned char* string )
{
  return glutBitmapLength( font, string ) ;
}

int gst_opengl_glutStrokeLength( void* font, const unsigned char* string )
{
  return glutStrokeLength( font, string ) ;
}

void gst_opengl_glutKeyboardFunc( void (* callback)( unsigned char, int, int ) )
{
  glutKeyboardFunc( callback );
}

void gst_opengl_glutSpecialFunc( void (* callback)( int, int, int ) )
{
  glutSpecialFunc( callback ) ;
}

void gst_opengl_glutReshapeFunc( void (* callback)( int, int ) )
{
  glutReshapeFunc( callback ) ;
}

void gst_opengl_glutVisibilityFunc( void (* callback)( int ) )
{
  glutVisibilityFunc( callback ) ;
}

void gst_opengl_glutDisplayFunc( void (* callback)( void ) )
{
  glutDisplayFunc( callback ) ;
}

void gst_opengl_glutMouseFunc( void (* callback)( int, int, int, int ) )
{
  glutMouseFunc( callback ) ;
}

void gst_opengl_glutMotionFunc( void (* callback)( int, int ) )
{
  glutMotionFunc( callback ) ;
}

void gst_opengl_glutPassiveMotionFunc( void (* callback)( int, int ) )
{
  glutPassiveMotionFunc( callback ) ;
}

void gst_opengl_glutEntryFunc( void (* callback)( int ) )
{
  glutEntryFunc( callback ) ;
}

void gst_opengl_glutKeyboardUpFunc( void (* callback)( unsigned char, int, int ) )
{
  glutKeyboardUpFunc( callback ) ;
}

void gst_opengl_glutSpecialUpFunc( void (* callback)( int, int, int ) )
{
  glutSpecialUpFunc( callback ) ;
}

void gst_opengl_glutJoystickFunc( void (* callback)( unsigned int, int, int, int ), int pollInterval )
{
  glutJoystickFunc( callback, pollInterval ) ;
}

void gst_opengl_glutMenuStateFunc( void (* callback)( int ) )
{
  glutMenuStateFunc( callback ) ;
}

void gst_opengl_glutMenuStatusFunc( void (* callback)( int, int, int ) )
{
  glutMenuStatusFunc( callback ) ;
}

void gst_opengl_glutOverlayDisplayFunc( void (* callback)( void ) )
{
  glutOverlayDisplayFunc( callback ) ;
}

void gst_opengl_glutWindowStatusFunc( void (* callback)( int ) )
{
  glutWindowStatusFunc( callback ) ;
}

void gst_opengl_glutSpaceballMotionFunc( void (* callback)( int, int, int ) )
{
  glutSpaceballMotionFunc( callback ) ;
}

void gst_opengl_glutSpaceballRotateFunc( void (* callback)( int, int, int ) )
{
  glutSpaceballRotateFunc( callback ) ;
}

void gst_opengl_glutSpaceballButtonFunc( void (* callback)( int, int ) )
{
  glutSpaceballButtonFunc( callback ) ;
}

void gst_opengl_glutButtonBoxFunc( void (* callback)( int, int ) )
{
  glutButtonBoxFunc( callback ) ;
}

void gst_opengl_glutDialsFunc( void (* callback)( int, int ) )
{
  glutDialsFunc( callback ) ;
}

void gst_opengl_glutTabletMotionFunc( void (* callback)( int, int ) )
{
  glutTabletMotionFunc( callback ) ;
}

void gst_opengl_glutTabletButtonFunc( void (* callback)( int, int, int, int ) )
{
  glutTabletButtonFunc( callback ) ;
}

void gst_initModule_glut(VMProxy* proxy) 
{
  proxy->defineCFunc ("glutInit", gst_opengl_glutInit) ;
  proxy->defineCFunc ("glutInitWindowPosition", glutInitWindowPosition) ;
  proxy->defineCFunc ("glutInitWindowSize", glutInitWindowSize) ;
  proxy->defineCFunc ("glutInitDisplayMode", glutInitDisplayMode) ;
  proxy->defineCFunc ("glutMainLoop", glutMainLoop) ;
  proxy->defineCFunc ("glutCreateWindow", glutCreateWindow) ;
  proxy->defineCFunc ("glutCreateSubWindow", glutCreateSubWindow) ;
  proxy->defineCFunc ("glutDestroyWindow", glutDestroyWindow) ;
  proxy->defineCFunc ("glutSetWindow", glutSetWindow) ;
  proxy->defineCFunc ("glutGetWindow", glutGetWindow) ;
  proxy->defineCFunc ("glutSetWindowTitle", glutSetWindowTitle) ;
  proxy->defineCFunc ("glutSetIconTitle", glutSetIconTitle) ;
  proxy->defineCFunc ("glutReshapeWindow", glutReshapeWindow) ;
  proxy->defineCFunc ("glutPositionWindow", glutPositionWindow) ;
  proxy->defineCFunc ("glutShowWindow", glutShowWindow) ;
  proxy->defineCFunc ("glutHideWindow", glutHideWindow) ;
  proxy->defineCFunc ("glutIconifyWindow", glutIconifyWindow) ;
  proxy->defineCFunc ("glutPushWindow", glutPushWindow) ;
  proxy->defineCFunc ("glutPopWindow", glutPopWindow) ;
  proxy->defineCFunc ("glutFullScreen", glutFullScreen) ;
  proxy->defineCFunc ("glutPostWindowRedisplay", glutPostWindowRedisplay) ;
  proxy->defineCFunc ("glutPostRedisplay", glutPostRedisplay) ;
  proxy->defineCFunc ("glutSwapBuffers", glutSwapBuffers) ;
  proxy->defineCFunc ("glutWarpPointer", glutWarpPointer) ;
  proxy->defineCFunc ("glutEstablishOverlay", glutEstablishOverlay) ;
  proxy->defineCFunc ("glutRemoveOverlay", glutRemoveOverlay) ;
  proxy->defineCFunc ("glutUseLayer", glutUseLayer) ;
  proxy->defineCFunc ("glutPostOverlayRedisplay", glutPostOverlayRedisplay) ;
  proxy->defineCFunc ("glutPostWindowOverlayRedisplay", glutPostWindowOverlayRedisplay) ;
  proxy->defineCFunc ("glutShowOverlay", glutShowOverlay) ;
  proxy->defineCFunc ("glutHideOverlay", glutHideOverlay) ;
  proxy->defineCFunc ("glutCreateMenu", glutCreateMenu) ;
  proxy->defineCFunc ("glutDestroyMenu", glutDestroyMenu) ;
  proxy->defineCFunc ("glutGetMenu", glutGetMenu) ;
  proxy->defineCFunc ("glutSetMenu", glutSetMenu) ;
  proxy->defineCFunc ("glutAddMenuEntry", glutAddMenuEntry) ;
  proxy->defineCFunc ("glutAddSubMenu", glutAddSubMenu) ;
  proxy->defineCFunc ("glutChangeToMenuEntry", glutChangeToMenuEntry) ;
  proxy->defineCFunc ("glutChangeToSubMenu", glutChangeToSubMenu) ;
  proxy->defineCFunc ("glutRemoveMenuItem", glutRemoveMenuItem) ;
  proxy->defineCFunc ("glutAttachMenu", glutAttachMenu) ;
  proxy->defineCFunc ("glutDetachMenu", glutDetachMenu) ;
  proxy->defineCFunc ("glutTimerFunc", gst_opengl_glutTimerFunc) ;
  proxy->defineCFunc ("glutIdleFunc", gst_opengl_glutIdleFunc) ;

  proxy->defineCFunc ("glutGet", glutGet) ;
  proxy->defineCFunc ("glutDeviceGet", glutDeviceGet) ;
  proxy->defineCFunc ("glutGetModifiers", glutGetModifiers) ;
  proxy->defineCFunc ("glutLayerGet", glutLayerGet) ;
  proxy->defineCFunc ("glutBitmapCharacter", gst_opengl_glutBitmapCharacter) ;
  proxy->defineCFunc ("glutBitmapWidth", gst_opengl_glutBitmapWidth) ;
  proxy->defineCFunc ("glutStrokeCharacter", gst_opengl_glutStrokeCharacter) ;
  proxy->defineCFunc ("glutStrokeWidth", gst_opengl_glutStrokeWidth) ;
  proxy->defineCFunc ("glutBitmapLength", gst_opengl_glutBitmapLength) ;
  proxy->defineCFunc ("glutStrokeLength", gst_opengl_glutStrokeLength) ;
  proxy->defineCFunc ("glutWireCube", glutWireCube) ;
  proxy->defineCFunc ("glutSolidCube", glutSolidCube) ;
  proxy->defineCFunc ("glutWireSphere", glutWireSphere) ;
  proxy->defineCFunc ("glutSolidSphere", glutSolidSphere) ;
  proxy->defineCFunc ("glutWireCone", glutWireCone) ;
  proxy->defineCFunc ("glutSolidCone", glutSolidCone) ;
  proxy->defineCFunc ("glutWireTorus", glutWireTorus) ;
  proxy->defineCFunc ("glutSolidTorus", glutSolidTorus) ;
  proxy->defineCFunc ("glutWireDodecahedron", glutWireDodecahedron) ;
  proxy->defineCFunc ("glutSolidDodecahedron", glutSolidDodecahedron) ;
  proxy->defineCFunc ("glutWireOctahedron", glutWireOctahedron) ;
  proxy->defineCFunc ("glutSolidOctahedron", glutSolidOctahedron) ;
  proxy->defineCFunc ("glutWireTetrahedron", glutWireTetrahedron) ;
  proxy->defineCFunc ("glutSolidTetrahedron", glutSolidTetrahedron) ;
  proxy->defineCFunc ("glutWireIcosahedron", glutWireIcosahedron) ;
  proxy->defineCFunc ("glutSolidIcosahedron", glutSolidIcosahedron) ;
  proxy->defineCFunc ("glutWireTeapot", glutWireTeapot) ;
  proxy->defineCFunc ("glutSolidTeapot", glutSolidTeapot) ;
  proxy->defineCFunc ("glutGameModeString", glutGameModeString) ;
  proxy->defineCFunc ("glutEnterGameMode", glutEnterGameMode) ;
  proxy->defineCFunc ("glutLeaveGameMode", glutLeaveGameMode) ;
  proxy->defineCFunc ("glutGameModeGet", glutGameModeGet) ;
  proxy->defineCFunc ("glutVideoResizeGet", glutVideoResizeGet) ;
  proxy->defineCFunc ("glutSetupVideoResizing", glutSetupVideoResizing) ;
  proxy->defineCFunc ("glutStopVideoResizing", glutStopVideoResizing) ;
  proxy->defineCFunc ("glutVideoResize", glutVideoResize) ;
  proxy->defineCFunc ("glutVideoPan", glutVideoPan) ;
  proxy->defineCFunc ("glutSetColor", glutSetColor) ;
  proxy->defineCFunc ("glutGetColor", glutGetColor) ;
  proxy->defineCFunc ("glutCopyColormap", glutCopyColormap) ;
  proxy->defineCFunc ("glutIgnoreKeyRepeat", glutIgnoreKeyRepeat) ;
  proxy->defineCFunc ("glutSetKeyRepeat", glutSetKeyRepeat) ;
  proxy->defineCFunc ("glutForceJoystickFunc", glutForceJoystickFunc) ;
  proxy->defineCFunc ("glutExtensionSupported", glutExtensionSupported) ;
  proxy->defineCFunc ("glutReportErrors", glutReportErrors) ;
  proxy->defineCFunc ("glutKeyboardFunc", gst_opengl_glutKeyboardFunc) ;
  proxy->defineCFunc ("glutSpecialFunc", gst_opengl_glutSpecialFunc) ;
  proxy->defineCFunc ("glutReshapeFunc", gst_opengl_glutReshapeFunc) ;
  proxy->defineCFunc ("glutVisibilityFunc", gst_opengl_glutVisibilityFunc) ;
  proxy->defineCFunc ("glutDisplayFunc", gst_opengl_glutDisplayFunc) ;
  proxy->defineCFunc ("glutMouseFunc", gst_opengl_glutMouseFunc) ;
  proxy->defineCFunc ("glutMotionFunc", gst_opengl_glutMotionFunc) ;
  proxy->defineCFunc ("glutPassiveMotionFunc", gst_opengl_glutPassiveMotionFunc) ;
  proxy->defineCFunc ("glutEntryFunc", gst_opengl_glutEntryFunc) ;
  proxy->defineCFunc ("glutKeyboardUpFunc", gst_opengl_glutKeyboardUpFunc) ;
  proxy->defineCFunc ("glutSpecialUpFunc", gst_opengl_glutSpecialUpFunc) ;
  proxy->defineCFunc ("glutJoystickFunc", gst_opengl_glutJoystickFunc) ;
  proxy->defineCFunc ("glutMenuStateFunc", gst_opengl_glutMenuStateFunc) ;
  proxy->defineCFunc ("glutMenuStatusFunc", gst_opengl_glutMenuStatusFunc) ;
  proxy->defineCFunc ("glutOverlayDisplayFunc", gst_opengl_glutOverlayDisplayFunc) ;
  proxy->defineCFunc ("glutWindowStatusFunc", gst_opengl_glutWindowStatusFunc) ;
  proxy->defineCFunc ("glutSpaceballMotionFunc", gst_opengl_glutSpaceballMotionFunc) ;
  proxy->defineCFunc ("glutSpaceballRotateFunc", gst_opengl_glutSpaceballRotateFunc) ;
  proxy->defineCFunc ("glutSpaceballButtonFunc", gst_opengl_glutSpaceballButtonFunc) ;
  proxy->defineCFunc ("glutButtonBoxFunc", gst_opengl_glutButtonBoxFunc) ;
  proxy->defineCFunc ("glutDialsFunc", gst_opengl_glutDialsFunc) ;
  proxy->defineCFunc ("glutTabletMotionFunc", gst_opengl_glutTabletMotionFunc) ;
  proxy->defineCFunc ("glutTabletButtonFunc", gst_opengl_glutTabletButtonFunc) ;

  _opengl_vm_proxy = proxy ;
}
