"  robot.st "
"  This program shows how to composite modeling transformations "
"  to draw translated and rotated hierarchical models. "
"  Interaction:  pressing the s and e keys (shoulder and elbow) "
"  alters the rotation of the robot arm. "

PackageLoader fileInPackage: 'OpenGL' !
Namespace current: OPENGL!

Object subclass:#Robot
	   instanceVariableNames: 'aWindow windowNumber shoulder elbow'
	   classVariableNames: ''
	   poolDictionaries: ''
	   category: 'OpenGL' !

!Robot methodsFor: 'initializing' !

init
	shoulder := 0.0.
	elbow := 0.0.
	aWindow := OpenGL new.
	aWindow glutInit: 'une surface smalltalkienne'.
	aWindow glutInitDisplayMode: ((OpenGL GlutRgb bitOr: OpenGL GlutDouble) bitOr: OpenGL GlutDepth).
	aWindow glutInitWindowSize: (Point x: 500 y: 500).
	aWindow glutInitWindowPosition: (Point x: 100 y: 100).

	windowNumber := aWindow glutCreateWindow: 'Une surface nurbs' . 
	
	" Init window color and shading model "
	aWindow glClearColor: (Color black).
	aWindow glShadeModel: OpenGL GlFlat.

	aWindow addCallback: OpenGL DisplayFuncEvent to: self selector: #display.
	aWindow addCallback: OpenGL KeyboardFuncEvent to: self selector: #keyboard:x:y:.
	aWindow addCallback: OpenGL ReshapeFuncEvent to: self selector: #reshape:height:.
!

display
	aWindow glClear: OpenGL GlColorBufferBit.
	aWindow glPushMatrix.
	aWindow glTranslatef: -1.0 y: 0.0 z: 0.0.
	aWindow glRotatef: shoulder direction: (Vertex x: 0.0 y: 0.0 z: 1.0).
	aWindow glTranslatef:  1.0 y: 0.0 z: 0.0.

	aWindow glPushMatrix.
	aWindow glScalef: 2.0 y: 0.4 z: 1.0.
	aWindow glutWireCube: 1.0.
	aWindow glPopMatrix.

	aWindow glTranslatef:  1.0 y: 0.0 z: 0.0.
	aWindow glRotatef: elbow direction: (Vertex x: 0.0 y: 0.0 z: 1.0).
	aWindow glTranslatef:  1.0 y: 0.0 z: 0.0.

	aWindow glPushMatrix.
	aWindow glScalef: 2.0 y: 0.4 z: 1.0.
	aWindow glutWireCube: 1.0.
	aWindow glPopMatrix.

	aWindow glPopMatrix.
	aWindow glutSwapBuffers.
!

reshape: w height: h
	aWindow glViewport: (Point x: 0 y: 0) extend: (Point x: w y: h).
	aWindow glMatrixMode: OpenGL GlProjection.
	aWindow glLoadIdentity.
 	aWindow gluPerspective: 65.0 aspect: (1.0*w/h) near: 1.0 far: 20.0.
	aWindow glMatrixMode: OpenGL GlModelview. 
	aWindow glLoadIdentity.
	aWindow glTranslatef: 0.0 y: 0.0 z: -5.0.
	!

keyboard: aKey x: aX y: aY
	aKey = $s ifTrue: [shoulder := (shoulder + 5)\\360. aWindow glutPostRedisplay.].
	aKey = $S ifTrue: [shoulder := (shoulder - 5)\\360. aWindow glutPostRedisplay.].
	aKey = $e ifTrue: [elbow := (elbow + 5)\\360. aWindow glutPostRedisplay.].
	aKey = $E ifTrue: [elbow := (elbow - 5)\\360. aWindow glutPostRedisplay.].
	!
!

Robot new init.
OpenGL mainIteration. !

