PackageLoader fileInPackage: 'OpenGL' !
Namespace current: OPENGL!

Object subclass:#OpenGLTest
	   instanceVariableNames: 'aWindow windowNumber eyePosition axeX axeY axeZ saveX'
	   classVariableNames: ''
	   poolDictionaries: ''
	   category: 'OpenGL' !

!OpenGLTest methodsFor: 'test' !

init
	" Define the position of the eye "
	eyePosition := Vertex x: 0.0 y: 0.0 z: 0.0.
	axeX := false. axeY := false. axeZ :=false.
	" Create the window and initialize callbacks "
	aWindow isNil ifTrue: 
		[ aWindow := OpenGL new. 
		  aWindow glutInit: 'une theiere smalltalkienne'.
		  aWindow glutInitDisplayMode: ((OpenGL GlutRgb bitOr: OpenGL GlutDouble) bitOr: OpenGL GlutDepth).
		  aWindow glutInitWindowSize: (Point x: 500 y: 500).
		  aWindow glutInitWindowPosition: (Point x: 100 y: 100).
		  windowNumber := aWindow glutCreateWindow: 'Une sphere...' . 

		  " Init window color and shading model "
		  aWindow glClearColor: (Color black).
		  aWindow glShadeModel: OpenGL GlSmooth.

		  aWindow glMaterialfv: OpenGL GlFront
				  mode: OpenGL GlSpecular
				  value: (Array with: 1.0 
								with: 0.0 
								with: 0.3 
								with: 0.5).

		  aWindow glMaterialf: OpenGL GlFront 
				  mode: OpenGL GlShininess 
				  value: 50.0.

		  aWindow glLightfv: OpenGL GlLight0
				  property: OpenGL GlPosition
				  value: (Array with: 1.0 
								with: 1.0 
								with: 1.0 
								with: 0.0).


		  aWindow glEnable: OpenGL GlLighting. 

		  aWindow glEnable: OpenGL GlLight0.
		  aWindow glEnable: OpenGL GlDepthTest.

		  aWindow addCallback: OpenGL IdleFuncEvent to: self selector: #idle.
		  aWindow addCallback: OpenGL DisplayFuncEvent to: self selector: #display.
		  aWindow addCallback: OpenGL ReshapeFuncEvent to: self selector: #reshape:height:.
		  aWindow addCallback: OpenGL MouseFuncEvent to: self selector: #mouse:state:x:y:.
		  aWindow addCallback: OpenGL MotionFuncEvent to: self selector: #suivi:y:.
		  ]!

display
	Transcript show: eyePosition asArray printString ; cr.
	aWindow glClear: (OpenGL GlColorBufferBit bitOr: OpenGL GlDepthBufferBit).
	aWindow glLoadIdentity.
	aWindow gluLookAt: (Vertex x: 0.0 y: 0.0 z: 5.0)
			center: (Vertex x: 0.0 y: 0.0 z: 0.0)
			up: (Vertex x: 0.0 y: 1.0 z: 0.0).
	aWindow glTranslatef: (Vertex x: -2.0 y: 0.0 z: 0.0).
	aWindow glRotatef: eyePosition x x: 1.0 y: 0.0 z: 0.0.
	aWindow glRotatef: eyePosition y x: 0.0 y: 1.0 z: 0.0.
	aWindow glRotatef: eyePosition z x: 0.0 y: 0.0 z: 1.0.
	aWindow glScalef: (Vertex x: 1.0 y: 2.0 z: 1.0).
	aWindow glutSolidTeapot: 1.0.
	aWindow glLoadIdentity.
	aWindow glTranslatef: (Vertex x: 2.0 y: 0.0 z: 0.0).
	aWindow glScalef: (Vertex x: 1.0 y: 2.0 z: 1.0).
	aWindow glutSolidSphere: 1.0 slices: 20 stacks: 16.
	aWindow glLoadIdentity.
	aWindow glutSwapBuffers.
	!

reshape: w height: h
	aWindow glViewport: (Point x: 0 y: 0) extend: (Point x: w y: h).
	aWindow glMatrixMode: OpenGL GlProjection.
	aWindow glLoadIdentity.
	aWindow glFrustum: -1.0 right: 1.0 bottom: -1.0 top: 1.0 near: 1.5 far: 20.0.
" 	w <= h  "
" 		ifTrue: [ "
" 			aWindow glOrtho: -1.5 right: 1.5  "
" 					bottom: (-1.5*h/w) top: (1.5*h/w) "
" 					near: -10.0 far: 10.0. "
" 			] "
" 		ifFalse: [ "
" 			aWindow glOrtho:(-1.5*w/h) right: (1.5*w/h)  "
" 					bottom: -1.5 top: 1.5  "
" 					near: -10.0 far: 10.0. "
" 			]. "
		
	aWindow glMatrixMode: OpenGL GlModelview. 
	aWindow glLoadIdentity.
	!

suivi: aX y: aY
	axeX ifTrue: [
		eyePosition x: (eyePosition x + (saveX - aX)).
		eyePosition x > 359 ifTrue: [eyePosition x: (eyePosition x - 360)].
		eyePosition x < 0 ifTrue: [eyePosition x: (360 + eyePosition x)].
		aWindow glutPostRedisplay.
		].
	axeY ifTrue: [
		eyePosition y: (eyePosition y + (saveX - aX)).
		eyePosition y > 359 ifTrue: [eyePosition y: (eyePosition y - 360)].
		eyePosition y < 0 ifTrue: [eyePosition y: (360 + eyePosition y)].
		aWindow glutPostRedisplay.
		].
	axeZ ifTrue: [
		eyePosition z: (eyePosition z + (saveX - aX)).
		eyePosition z > 359 ifTrue: [eyePosition z: (eyePosition z - 360)].
		eyePosition z < 0 ifTrue: [eyePosition z: (360 + eyePosition z)].
		aWindow glutPostRedisplay.
		].
	saveX := aX .
	!


mouse: aButton state: aState x: aX y: aY
	"aButton printString printNl."
	aButton = OpenGL GlutLeftButton
		ifTrue: [
			axeX := (aState = OpenGL GlutDown).
			].
	aButton > OpenGL GlutRightButton
		ifTrue: [
			axeY := (aState = OpenGL GlutDown).
			].
	aButton = OpenGL GlutRightButton
		ifTrue: [
			axeZ := (aState = OpenGL GlutDown).
			].
	saveX := aX.
	!
idle
	Processor yield !
!


!OpenGLTest methodsFor: 'access' !
window
	^aWindow !
window: a
	aWindow := a! 
!

OpenGLTest new init.
OpenGL mainIteration. !
