PackageLoader fileInPackage: 'OpenGL' !
Namespace current: OPENGL!

Object subclass:#OpenGLTest
	   instanceVariableNames: 'aWindow windowNumber eyePosition axeX axeY axeZ saveX'
	   classVariableNames: ''
	   poolDictionaries: ''
	   category: 'OpenGL' !

!OpenGLTest methodsFor: 'test' !

init
	" Define the position of the eye "
	eyePosition := Vertex x: 0.0 y: 0.0 z: 5.0.
	axeX := false. axeY := false. axeZ :=false.
	" Create the window and initialize callbacks "
	aWindow isNil ifTrue: 
		[ aWindow := OpenGL new. 
		  aWindow glutInit: 'une sphere smalltalkienne'.
		  aWindow glutInitDisplayMode: ((OpenGL GlutRgb bitOr: OpenGL GlutDouble) bitOr: OpenGL GlutDepth).
		  aWindow glutInitWindowSize: (Point x: 500 y: 500).
		  aWindow glutInitWindowPosition: (Point x: 100 y: 100).
		  windowNumber := aWindow glutCreateWindow: 'Une sphere...' . 

		  " Init window color and shading model "
		  aWindow glClearColor: (Color black).
		  aWindow glShadeModel: OpenGL GlSmooth.

		  aWindow glMaterialfv: OpenGL GlFront
				  mode: OpenGL GlSpecular
				  value: (Array with: 1.0 
								with: 1.0 
								with: 1.0 
								with: 1.0).

		  aWindow glMaterialf: OpenGL GlFront 
				  mode: OpenGL GlShininess 
				  value: 50.0.

		  aWindow glLightfv: OpenGL GlLight0
				  property: OpenGL GlPosition
				  value: (Array with: 1.0 
								with: 1.0 
								with: 1.0 
								with: 0.0).

		  aWindow glEnable: OpenGL GlLighting. 
		  aWindow glEnable: OpenGL GlLight0.
		  aWindow glEnable: OpenGL GlDepthTest.

		  aWindow addCallback: OpenGL DisplayFuncEvent to: self selector: #display.
		  aWindow addCallback: OpenGL ReshapeFuncEvent to: self selector: #reshape:height:.
		  ]!

display
	aWindow glClear: (OpenGL GlColorBufferBit bitOr: OpenGL GlDepthBufferBit).
	aWindow glutSolidSphere: 1.0 slices: 50 stacks: 16.
	aWindow glutSwapBuffers.
	!

reshape: w height: h
	aWindow glViewport: (Point x: 0 y: 0) extend: (Point x: w y: h).
	aWindow glMatrixMode: OpenGL GlProjection.
	aWindow glLoadIdentity.
	w <= h 
		ifTrue: [
			aWindow glOrtho: -1.5 right: 1.5 
					bottom: (-1.5*h/w) top: (1.5*h/w)
					near: -10.0 far: 10.0.
			]
		ifFalse: [
			aWindow glOrtho:(-1.5*w/h) right: (1.5*w/h) 
					bottom: -1.5 top: 1.5 
					near: -10.0 far: 10.0.
			].
		
	aWindow glMatrixMode: OpenGL GlModelview. 
	aWindow glLoadIdentity.
	!
!


!OpenGLTest methodsFor: 'access' !
window
	^aWindow !
window: a
	aWindow := a! 
!

OpenGLTest new init.
OpenGL mainIteration. !
